package grada;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;

/** Diese Klasse stellt eine Oberflche fr die Anzeige von HTML-Seiten zur 
 * Verfgung.In unserem Fall wird sie verwendet, um die Hilfe anzuzeigen. Auch 
 * wenn diese Lsung nicht die beste ist (denn CSS uvm. wird nicht oder nur 
 * unvollstndig von java untersttzt), bietet sie eine die Mglichkeit einen 
 * Text deutlich einfacher als mit Labels zu gestalten.
 * @author Thilo Beckmann
 * @version 08.07.05
 */
public class HtmlHilfe extends JPanel {

	JEditorPane htmlseite;
	/** Konstruktor.
	 * erstellt eine Oberflche fr die Anzeige der HTML-Seiten.
	 */
	public HtmlHilfe() {
		setLayout(new GridLayout());
		try {
			URL url = null;
			String path = null;
			try {
				path = "/hilfe/index.html"; // hier wird gestartet.
				url = getClass().getResource(path);
			} catch (Exception e) {
				System.err.println("Failed to open " + path);
				url = null;
			}
			
			if(url != null) {
				htmlseite = new JEditorPane(url);
				htmlseite.setEditable(false);
				htmlseite.addHyperlinkListener(createHyperLinkListener());
				htmlseite.setContentType("text/html");
				
				JScrollPane scroller = new JScrollPane();
				JViewport vp = scroller.getViewport();
				vp.add(htmlseite);
				add(scroller, BorderLayout.CENTER);
			}
		} 
		catch (MalformedURLException e) {
			System.out.println("Malformed URL: " + e);
		} 
		catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}
	
	/** Verarbeitung von Link-Events.
	 * 
	 * @return gibt einen neuen HyperlinkListener zurck.
	 */
	public HyperlinkListener createHyperLinkListener() {
		return new HyperlinkListener() {
	    public void hyperlinkUpdate(HyperlinkEvent e) {
	    	if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
	    		if (e instanceof HTMLFrameHyperlinkEvent) {
	    			((HTMLDocument)htmlseite.getDocument()).processHTMLFrameHyperlinkEvent((HTMLFrameHyperlinkEvent)e);
	    		} 
	    		else {
	    			try {
	    				htmlseite.setPage(e.getURL());
	    			} 
	    			catch (IOException ioe) {
	    				System.out.println("IOE: " + ioe);
	    			}
	    		}
	    	}
	    }
	};
	}
	
	void updateDragEnabled(boolean dragEnabled) {
		htmlseite.setDragEnabled(dragEnabled);
	}
}
