package grada;

import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ListResourceBundle;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JWindow;

import sprachen.Sprachen;


/** Zeigt Infos.
 * Hier werden Copyrighthinweise, die Autoren und vieles mehr in einem schnen
 * Kstchen angezeigt.
 * @author Thilo Beckmann
 * @version 05.07.05
 */
public class InfoUeberProgramm implements MouseListener{
	private static Sprachen				sprachen	= Sprachen.holeSprache();
	private static ListResourceBundle	sp			= sprachen.holeSprachBundle();
	private JWindow infoUeberProgrammFenster;
	private JLabel l;
	private JFrame f;
	/** Konstruktor.
	 * es wird ein Fenster erstellt, das als Elternteil das angegebene
	 * JFrame hat, somit ist es abhngig davon. Das Fenster wird durch 
	 * einen Mausklick geschlossen.
	 * 
	 * @param f Frame, von wo aus dieses Fenster gestartet wird.
	 */
	public InfoUeberProgramm(JFrame f){
		this.f = f;
		l = new JLabel(new ImageIcon(sp.getString("InfoberProgramm_Bild")));
		infoUeberProgrammFenster = new JWindow(f);
		infoUeberProgrammFenster.getContentPane().add(l);
		infoUeberProgrammFenster.pack();
		infoUeberProgrammFenster.addMouseListener(this);
		Rectangle screenRect = f.getGraphicsConfiguration().getBounds();
		infoUeberProgrammFenster.setLocation(
		screenRect.x + screenRect.width/2 
		- infoUeberProgrammFenster.getSize().width/2,
		screenRect.y + screenRect.height/2 
		- infoUeberProgrammFenster.getSize().height/2);	
		zeigeInfoUeberProgramm();
	}
	
	/** zeigt das Fenster an.
	 */
	public void zeigeInfoUeberProgramm() {
		infoUeberProgrammFenster.setVisible(true);
	}
	/** entfernt / blendet das Fenster wieder aus.
	 */
	public void entferneInfoUeberProgramm() {
		infoUeberProgrammFenster.setVisible(false);
		infoUeberProgrammFenster.dispose();
		infoUeberProgrammFenster = null;
		l = null;	
	}
	
	public void mouseClicked(MouseEvent e){entferneInfoUeberProgramm();}
	public void mouseExited(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mousePressed(MouseEvent e){}
	public void mouseReleased(MouseEvent e){}
}
