package grada;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import parser.*;
import java.net.*;
import sprachen.Sprachen;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.colorchooser.*;
import javax.swing.filechooser.*;
import javax.accessibility.*;

import java.lang.reflect.*;
import java.awt.*;
import java.awt.peer.*;
import java.beans.*;
import java.util.*;
import java.io.*;
import java.applet.*;
import java.net.*;

/** Das Programm.
 * Hier fngt alles an, der Benutzer kann verschiedene Optionen aufrufen und 
 * somit Instanzen der unterschiedlichen Benutzeroberflchen erzeugen. Diese 
 * knnen parallel nebeneinander laufen. Die Registerkarten bieten dazu eine 
 * angemessene bersicht.
 * @author Thilo Beckmann
 * @version 09.07.05
*/
public class Programm extends JPanel{
	
	static public boolean aktualisierenErlaubt = true;
	
	private static Sprachen	sprachen = Sprachen.holeSprache();
	private static ListResourceBundle	sp = sprachen.holeSprachBundle();
	static StartBildschirm info;
	private JFrame f = null;
	
	private int aktiveRegisterKarte = 0;
	
	private Graphics g = getGraphics();
	
	private ActionListener	aktionsHaendler = new AktionsHaendler();
	private FensterHaendler fensterHaendler = new FensterHaendler();
	
	private ProgrammApplet applet = null;
	
	private JTabbedPane	registerKarten;
	private int registerKartenMaxId=0;
	private ImageIcon	zeichenGraph				
		= new ImageIcon ("grafik/icons/graph24.gif");
	private ImageIcon	zeichenSpielPunkteTreffen	
		= new ImageIcon ("grafik/icons/punktetreffen24.gif");
	private ImageIcon	zeichenSpielGraphenRaten	
		= new ImageIcon ("grafik/icons/graphenraten24.gif");
	private ImageIcon	zeichenHtmlHilfe			
		= new ImageIcon ("grafik/icons/htmlhilfe24.gif");	

	/** Konstruktor.
	 * Eine Instanz dieser Klasse ist die oberste Benutzeroberflche,
	 * auf der der Benutzer die verschiedenen Elemente aufrufen kann
	 */
	public Programm(ProgrammApplet applet){
		this(applet,null);
	}
	
	public Programm(ProgrammApplet applet, GraphicsConfiguration gc){
		this.applet = applet;
		
		registerKarten	= new JTabbedPane(JTabbedPane.TOP,
				JTabbedPane.SCROLL_TAB_LAYOUT);
		
		if (applet == null) {
			f = new JFrame("Das Programm (c) Thilo Beckmann, Felix Bleckmann, " +
					"Christian Bormann, Stephan Hagebck",gc);
			// damit das Fragen auch Sinn macht
			f.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE); 
		}
		
		
		init();
		registerKarten.addTab(sp.getString("Prog_Graph"),zeichenGraph,
				new FunktionenAnzeigen("Ax^2+B"),
				sp.getString("Prog_TTTFunktionen Anzeige"));
		registerKarten.addChangeListener(fensterHaendler);
	}
	
	
	/** Setzt die Orientierung der Registerkarten.
	 * @param orientierung	Gibt die Orientierung der Registerkarten an
	 */
	private void setzeOrientierungDerRegisterKarten(int orientierung){
		registerKarten.setTabPlacement(orientierung);
	}
	
	
	/** Erstellt die Menuleiste.
	 * In dieser Methode werden die Menueintrge erstellt. 
	 */
	private JMenuBar erstelleMenuListe(){
		// Erstelle die Menleiste, in der alle verfgbaren Funktionen des
		// Programms zur Auswahl stehen: 
		JMenuBar mb = new JMenuBar();
		JMenu datei = new JMenu(sp.getString("Prog_Datei"));
			JMenu dateiNeu = new JMenu(sp.getString("Prog_Neu"));
			JMenu dateiNeuGraph = new JMenu(sp.getString("Prog_Graph"));
				dateiNeuGraph.add(macheMenuItem(sp.getString("Prog_Eigener"),"datei neu graph eigener",	aktionsHaendler));
				dateiNeuGraph.add(macheMenuItem(sp.getString("Prog_Polynom"),"datei neu graph polynom",	aktionsHaendler));
				dateiNeuGraph.add(macheMenuItem(sp.getString("Prog_Sinus/Cosinus"),"datei neu graph sinus",	aktionsHaendler));
				dateiNeuGraph.add(macheMenuItem(sp.getString("Prog_E (Eulerische Zahl)"),"datei neu graph e",aktionsHaendler));
				dateiNeu.add(dateiNeuGraph);
				JMenu dateiNeuSpiel = new JMenu(sp.getString("Prog_Spiel"));
				JMenu dateiNeuSpielPunkteTreffen = new JMenu(sp.getString("Prog_PunkteTreffen"));
					dateiNeuSpielPunkteTreffen.add(macheMenuItem(sp.getString("Prog_Einfach"),"datei neu spiel punktetreffen einfach",aktionsHaendler));
					dateiNeuSpielPunkteTreffen.add(macheMenuItem(sp.getString("Prog_Mittel"),"datei neu spiel punktetreffen mittel",aktionsHaendler));
					dateiNeuSpielPunkteTreffen.add(macheMenuItem(sp.getString("Prog_Schwer"),"datei neu spiel punktetreffen schwer",aktionsHaendler));
					dateiNeuSpiel.add(dateiNeuSpielPunkteTreffen);
				dateiNeu.add(dateiNeuSpiel);
				dateiNeu.add(macheMenuItem(sp.getString("Prog_Poly"),"datei neu poly",aktionsHaendler));
				
			datei.add(dateiNeu);
			datei.add(new JSeparator());
			datei.add(macheMenuItem(sp.getString("Prog_Speichern"),"datei speichern",aktionsHaendler));
			datei.add(macheMenuItem(sp.getString("Prog_Laden"),"datei laden",aktionsHaendler));
			datei.add(new JSeparator());
			datei.add(macheMenuItem(sp.getString("Prog_Schlieen"),"datei schlieen",aktionsHaendler));
			datei.add(macheMenuItem(sp.getString("Prog_Alle Schlieen"),"datei alle schlieen",aktionsHaendler));
			datei.add(macheMenuItem(sp.getString("Prog_Alle anderen Schlieen"),"datei alle anderen schlieen",aktionsHaendler));
			datei.add(new JSeparator());
			datei.add(macheMenuItem(sp.getString("Prog_Beenden"),"datei beenden",aktionsHaendler));
		mb.add(datei);
		JMenu optionen = new JMenu(sp.getString("Prog_Optionen"));
		JMenu optionenRegOri = new JMenu ("Registerkarten Orientierung");
		ButtonGroup optionenRegOriButtonGroup = new ButtonGroup();
		JRadioButtonMenuItem regOriOben   = macheRadioButtonMenuItem(optionenRegOriButtonGroup,"Oben",  "optionen reg ori oben",   aktionsHaendler);
		JRadioButtonMenuItem regOriUnten  = macheRadioButtonMenuItem(optionenRegOriButtonGroup,"Unten", "optionen reg ori unten",  aktionsHaendler);
		JRadioButtonMenuItem regOriLinks  = macheRadioButtonMenuItem(optionenRegOriButtonGroup,"Links", "optionen reg ori links",  aktionsHaendler);
		JRadioButtonMenuItem regOriRechts = macheRadioButtonMenuItem(optionenRegOriButtonGroup,"Rechts","optionen reg ori rechts", aktionsHaendler);
		optionenRegOri.add(regOriOben);
		optionenRegOri.add(regOriUnten);
		optionenRegOri.add(regOriLinks);
		optionenRegOri.add(regOriRechts);
		optionen.add(optionenRegOri);
		mb.add(optionen);
		
		JMenu hilfe = new JMenu(sp.getString("Prog_Hilfe"));
		hilfe.add(macheMenuItem(sp.getString("Prog_Benutzer Hilfe"),"hilfe html",aktionsHaendler));
		hilfe.add(macheMenuItem(sp.getString("Prog_ber"),"hilfe ueber",aktionsHaendler));
		mb.add(hilfe);
		return mb;
	}
	
	/** erstellt ein Eintrag fr ein Menu. 
	* Diese Funktion fgt einem bestimmten Men eine neue Auswahl hinzu,
	* die den angegebenen Titel, den angegebenen ActionCommand und den
	* angegebenen ActionListener hat.
	* @param titel		Titel des Eintrages
	* @param act		String, wird dem Eintrag als ActionCommand zugewiesen
	* @param haendler	ActionListener, der dem Eintrag zugeordnet wird 
	* @return 			ein neues MenuItem mit angegebenen Eigenschaften
	*/
	private JMenuItem macheMenuItem(String titel, String act, 
			ActionListener haendler){
		JMenuItem menuitem = new JMenuItem(titel);
		menuitem.setActionCommand(act);
		menuitem.addActionListener(haendler);
		return menuitem;
	}
	/** erstellt ein RadioButton fr ein Menu
	 * Diese Funktion fasst einige Schritte zusammen, die fr eine erfolgreiche 
	 * Hinzufgung zu einem Men wichtig sind.
	 * @param group		ButtonGroup, der dieser RadioButton angehren soll
	 * @param titel		Text fr die Beschriftung
	 * @param act		Text fr den ActionCommand
	 * @param haendler	ActionListener, der dem RadioButton zugeordnet wird
	 * @return			gibt ein JRadioButton mit den angegebenen Eigenschaften 
	 * 					zurck
	 */
	private JRadioButtonMenuItem macheRadioButtonMenuItem(ButtonGroup group, 
			String titel, String act, ActionListener haendler){
		JRadioButtonMenuItem radiobutton = new JRadioButtonMenuItem(titel);
		radiobutton.setActionCommand(act);
		radiobutton.addActionListener(haendler);
		group.add(radiobutton);
		return radiobutton;
	}
    
	/** Initialisiert das Frame
	 * Hier werden Gre, Listener, etc gesetzt (/initialisiert)
	 */
	private void init(){
		if (applet == null){
			f.setSize(700,500);
			f.setJMenuBar(erstelleMenuListe());
			f.getContentPane().add(registerKarten);
			f.addWindowListener(fensterHaendler);
			f.addComponentListener(fensterHaendler);
			f.setVisible(true);
		}
		else {
			applet.setSize(700,500);
			applet.setJMenuBar(erstelleMenuListe());
			applet.getContentPane().add(registerKarten);
			//applet.addComponentListener(fensterHaendler);
			applet.setVisible(true);
		}
	}
	
	/** Main-Methode.
	 * Diese Methode wird bei Programmstart aufgerufen und erstellt eine 
	 * Instanz dieser Klasse.
	 * @param args	String an Argumenten, die bergeben werden knnen 
	 */
	/*public static void main (String args[]){
		System.out.println("(c) Thilo Beckmann, Felix Bleckmann, " +
				"Christian Bormann, Stephan Hagebck");
		info = new StartBildschirm(new JFrame());
		pause(1500);
		Programm prog = new Programm();
		info.entferneStartBildschirm();
	}*/
    public static void main(String[] args) {
    	// Create SwingSet on the default monitor
		System.out.println("(c) Thilo Beckmann, Felix Bleckmann, " +
		"Christian Bormann, Stephan Hagebck");
		info = new StartBildschirm(new JFrame());
		pause(1500);
		
    	Programm prog = new Programm(null, GraphicsEnvironment.
    			getLocalGraphicsEnvironment().
				getDefaultScreenDevice().
				getDefaultConfiguration());
    	info.entferneStartBildschirm();
    }

	
	/** Macht Pause.
	 * bei Aufruf dieser Methode wird eine Pause in der Bearbeitung eingeleg
	 * @param dauer	Zeitdauer der Pause in msec
	 */
	public static void pause(int dauer){
		try{Thread.sleep(dauer);}
		catch(InterruptedException e){return;}
	}	
	
	/** Aktualisiert die aktuelle Registerkarte.
	 * Aktualisiert die aktuelle Registerkarte und ruft je nach Inhalt dieser 
	 * Registerkarte die Aktualisierung-Methode auf.
	 */
	public void aktualisiereRegisterKarte(){
		if (registerKarten.getTabCount()>0 && Parser.aktualisierenErlaubt){
			Component c = registerKarten.getComponentAt(registerKarten.getSelectedIndex());
			if (c instanceof FunktionenAnzeigen){
				((FunktionenAnzeigen)c).aktualisiere();
			}
		}
	}
	
	/** der AktionsHaendler.
	 * Diese InnerClass behandelt ausgewhlten bzw. angeklickten Meneintrge
	 * und erstellt je nach Wunsch des Benutzers die gewnschten Elemente
	 * @author Thilo Beckmann
	 * @version 27.02.05
	 */
	class AktionsHaendler implements ActionListener {
		public void actionPerformed(ActionEvent e){
			String kommando = e.getActionCommand();
			if (kommando=="datei neu graph eigener"){
				registerKarten.addTab(sp.getString("Prog_Graph"),zeichenGraph,new FunktionenAnzeigen(),sp.getString("Prog_TTTFunktionen Anzeige"));
				registerKartenMaxId++;
			}
			else if (kommando=="datei neu graph polynom"){
				registerKarten.addTab(sp.getString("Prog_Graph"),zeichenGraph,new FunktionenAnzeigen("A*x^5+B*x^4+C*x^3+D*x^2+E*x^1+F*x^0"),sp.getString("Prog_TTTFunktionen Anzeige"));
				registerKartenMaxId++;
			}
			else if (kommando=="datei neu graph sinus"){
				registerKarten.addTab(sp.getString("Prog_Graph"),zeichenGraph,new FunktionenAnzeigen("A*sin(B*x)"),sp.getString("Prog_TTTFunktionen Anzeige"));
				registerKartenMaxId++;
			}
			else if (kommando=="datei neu graph e"){
				registerKarten.addTab(sp.getString("Prog_Graph"),zeichenGraph,new FunktionenAnzeigen("A*e^(B*x)"),sp.getString("Prog_TTTFunktionen Anzeige"));
				registerKartenMaxId++;
			}
			else if (kommando=="datei neu poly"){
				registerKarten.addTab(sp.getString("Prog_Poly"),zeichenGraph,new PolynomDivision(),sp.getString("Prog_TTTFunktionen Anzeige"));
				registerKartenMaxId++;
			}
			else if (kommando=="datei speichern"){
				Component c = registerKarten.getComponentAt(registerKarten.getSelectedIndex());
				if (c instanceof FunktionenAnzeigen){
					((FunktionenAnzeigen)c).speicherFunkionenInDatei();
				}
			}
			else if (kommando=="datei laden"){
				Component c = registerKarten.getComponentAt(registerKarten.getSelectedIndex());
				if (c instanceof FunktionenAnzeigen){
					((FunktionenAnzeigen)c).ladeFunktionenAusDatei();
				}
			}
			else if (kommando=="datei beenden"){
				fensterHaendler.windowClosing(new WindowEvent(f,0));
			}
			else if (kommando=="datei schlieen"){
				registerKarten.removeTabAt(registerKarten.getSelectedIndex());
			}
			else if (kommando=="datei alle anderen schlieen"){
				int anzahlKarten = registerKarten.getTabCount();
				while (anzahlKarten-- > 0) {
					if (registerKarten.getSelectedIndex()!=anzahlKarten){
						registerKarten.removeTabAt(anzahlKarten);
					}
				}	
			}
			else if (kommando=="datei alle schlieen"){
				registerKarten.removeAll();
			}
			else if (kommando.startsWith("datei neu spiel punktetreffen")){
				if (kommando.endsWith("einfach")){
					registerKarten.addTab(sp.getString("Prog_Pkt-Treffen"),zeichenSpielPunkteTreffen,new PunkteTreffen(PunkteTreffen.EINFACH),sp.getString("Prog_TTTSpiel: Punkte Treffen"));
				}
				else if (kommando.endsWith("mittel")){
					registerKarten.addTab(sp.getString("Prog_Pkt-Treffen"),zeichenSpielPunkteTreffen,new PunkteTreffen(PunkteTreffen.MITTEL),sp.getString("Prog_TTTSpiel: Punkte Treffen"));
				}
				else if (kommando.endsWith("schwer")){
					registerKarten.addTab(sp.getString("Prog_Pkt-Treffen"),zeichenSpielPunkteTreffen,new PunkteTreffen(PunkteTreffen.SCHWER),sp.getString("Prog_TTTSpiel: Punkte Treffen"));
				}
			}
			else if (kommando=="optionen reg ori oben"){	setzeOrientierungDerRegisterKarten(JTabbedPane.TOP);}
			else if (kommando=="optionen reg ori rechts"){	setzeOrientierungDerRegisterKarten(JTabbedPane.RIGHT);}
			else if (kommando=="optionen reg ori unten"){	setzeOrientierungDerRegisterKarten(JTabbedPane.BOTTOM);}
			else if (kommando=="optionen reg ori links"){	setzeOrientierungDerRegisterKarten(JTabbedPane.LEFT);}
			
			else if (kommando=="hilfe html"){
				registerKarten.addTab(sp.getString("Prog_Hilfe"),zeichenHtmlHilfe,new HtmlHilfe(),sp.getString("Prog_TTTHilfe"));
			}
			else if (kommando=="hilfe ueber"){
				InfoUeberProgramm infoUeberProgramm = new InfoUeberProgramm(f);
			}
		}
	}
	
	/** der FensterHaendler.
	 * Diese InnerClass sorgt fr die Behandlung aller mit dem Fenster 
	 * zusammenhngenden Ereigbnisse, z.B. wenn das Fenster geschlossen 
	 * werden soll, wird nochmal nachgefragt, ob man etwas speichern mchte etc.  
	 * @author	Thilo Beckmann
	 * @version	27.02.05
	 */
	class FensterHaendler implements WindowListener, ComponentListener, ChangeListener {
		int beenden;
		public void stateChanged(ChangeEvent e){}
		public void windowActivated(WindowEvent e){
			aktualisiereRegisterKarte();
		}
		public void windowClosed(WindowEvent e){
			System.out.println(">--< Programm beendet >--<");
			System.exit(0);
		}
		public void windowClosing(WindowEvent e){
			System.out.println(">--< Programm beendet >--<");
			if (registerKarten.getTabCount()>0){
				beenden = JOptionPane.showConfirmDialog(f,sp.getString("Prog_Soll das Programm wirklich beendet werden?"));
			}
			else beenden=JOptionPane.YES_OPTION;
			if (beenden==JOptionPane.YES_OPTION){
				f.dispose();
				System.exit(0);
			}
		}
		public void windowDeactivated(WindowEvent e){
			aktualisiereRegisterKarte();
		}
		public void windowDeiconified(WindowEvent e){
			aktualisiereRegisterKarte();
		}
		public void windowIconified(WindowEvent e){}
		public void windowOpened(WindowEvent e){
			aktualisiereRegisterKarte();
		}
		
		public void componentHidden(ComponentEvent e){}
		public void componentResized(ComponentEvent e){
			aktualisiereRegisterKarte();
		}
		public void componentMoved(ComponentEvent e){
			//aktualisiereRegisterKarte();
		}
		public void componentShown(ComponentEvent e){}
	}
}