package grada;

import grada.geometriefiguren.Funktion;
import grada.geometriefiguren.Punkt;
import grada.geometriefiguren.Punkt2d;
import grada.geometriefiguren.Beschriftung;
import grada.interfaces.InterfaceParserEingabe;


import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.BasicStroke;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.lang.Double;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.event.MouseInputAdapter;
import javax.swing.JTextField;

import parser.Parser;


/**
 * Hier kommt ne dicke Beschreibung der Klasse hin.
 * 
 * @author		Christian Bormann
 * @version		30.06.05
 */
public class Schaubild extends JPanel implements ActionListener {
	
	Graphics2D g2d;
	
	/** Die Farbe in der die Achsen dargestellt werden */
	private Color achsenfarbe;
	/** Die Farbe in der das Gitter dargestellt wird */
	private Color gitterfarbe;
	/** Die Farbe in der der Hintergrund gezeichnet wird */
	private Color hintergrundfarbe;
	/** Die Farbe in der die AnzeigeAnMaus dargestellt wird */
	private Color anzeigeanmausfarbe;
	
	/** Die Normaleinheit stellt den Pixelwert fr "1" 
	* bei normaler Darstellung dar. Fr die Darstellung der Achsen wichtig
	*/
	private static int normaleinheit;
	
	/** vergr_x und vergr_y beinhalten die "reale" Vergrerungsstufe, also 
	 * z.B. 2 oder 0,5 
	 */
	private double vergr_x;
	private double vergr_y;
	
	/** vergr_speicher_x und vergr_speicher_y speichern den x/y
	* Vergrsserungswert, so wie er bergeben wird 
	* z.B. 1,2,3...
	*/
	private int vergr_speicher_x;
	private int vergr_speicher_y;
	
	/** anfang_x / ende_x  und anfang_y / ende_y begrenzen den Raum,
	* der gerade dargestellt wird. Sie werden beim verschieben mit 
	* der Maus verndert 	
	*/
	private int pixel_maxx;
	private int pixel_maxy;
		
	private double anfang_x;
	private double ende_x;
	private double anfang_y;
	private double ende_y;
	
	/** Eine Boolean durch die die Anzeige des Gitters
	* an und aus geschaltet werden kann ( siehe zeichne_achsen funktionen )
	*/
	private boolean gitter;
	
	/** Eine Boolean durch die die Anzeige an der Maus ein oder ausgeschaltet 
	* wird ( siehe mouseMoved ) 
	*/
	private boolean anzeigeanmaus;
	
	/** alte x-Position der Maus (zum Erstellen des Verschiebungseffektes) */
	private int mouse_alt_x;
	/** alte y-Position der Maus (zum Erstellen des Verschiebungseffektes) */
	private int mouse_alt_y;
	/** Hier werden die aktuellen Funktionen gespeichert */
	private Collection funktionen_sicher;
	/** Hier werden die aktuellen Punkte gespeichert */
	private Collection punkte_sicher;
	/** Hier werden die en gespeichert */
	private ArrayList beschriftungen;
	/** Dieser Wert verndert die Genauigkeit beim Zeichnen einer Funktion Je 
	 * grer der Wert wird desto mehr Pixel liegen zwischen 2 Punkten der 
	 * Funktion */	
	private double funktionGenauigkeit;
	/** Hier werden die von dem Parser bergebenen Punkte gespeichert falls 
	 * schnell neu gezeichnet werden muss*/
	private InterfaceParserEingabe platzSpeicher;
	/** Der Parser fr dieses Schaubild wird gespeichert */
	private Parser p;
	/** Der Cursor zum verschieben */
	private Cursor zeiger_verschieben;
	/** Der Cursor zum verschieben */
	private Cursor zeiger_normal;
	/** Es wird das verschieben des schaubildes erlaubt oder verweigert */
	private boolean mausverschieben;
	/** Luft ein Spiel ? */
	private boolean spiel;
	/** Wie gro ist das Feld des Feldes in dem die Mauskoordinaten stehen */
	private int tipgroesse;
	/** Wird eine Beschriftung gerade verschoben ? 0 = nein, sonst 1,2,3,4,5...*/
	private int beschriftungv;
	/** Antialising an/aus*/
	private Object antialising;
	/** Dicke der Funktionen*/
	private int funktionsdicke;
	
	/** Fr das PopMenu */
	/**-----------------*/
	
	/** Speicher fr die Farbe bei der Auswahl */
	private Color ausgewaehlteFarbe;
	/** Panel fr die Farbauswahl */
	private JPanel fpanel;
	
	/** Die Position im Menue, wo die Ableitungen angezeigt werden */
	private int ableitungposi;

	
	/** Werden fr das Popupmenu benoetigt ! */
	private ButtonGroup grouper;
	private JPopupMenu mbar;
	private JMenu submenu,ssubmenu;
	private JMenuItem menuItem;
	private JRadioButtonMenuItem rbMenuItem;
	private JCheckBoxMenuItem cbMenuItem;
	private JLabel la;
	private JTextField txt;
	
	public Schaubild(InterfaceParserEingabe referer){
		System.out.println("Schaubild erstellt");
		// Wo bin ich ?
		platzSpeicher = referer;
		// x-vergrerung auf 1 = standard
		vergr_speicher_x = 1;
		// y-vergrerung auf 1 = standard
		vergr_speicher_y = 1;
		// x-vergrerung auf 1.0 = standard
		vergr_x = 1.0;
		// y-vergrerung auf 1.0 = standard
		vergr_y = 1.0;
		// die Pixel die fr eine Einheit am Anfang gesetzt werden
		normaleinheit = 60;
		// Die Farbe des Hintergrundes
		hintergrundfarbe = Color.white;
		// Die Farbe der Achsen und deren Beschriftung wird auf schwarz gesetz
		achsenfarbe = Color.black;
		// Die Farbe des Gitters wird auf ein helles Grau gesetzt
		gitterfarbe = Color.lightGray;
		// Die Farbe fr die Information ber die Maus
		anzeigeanmausfarbe = Color.blue;
		// Das Gitter wird angeschaltet
		gitter = true;
		// anzeigeanmaus wird angeschaltet
		anzeigeanmaus = false;
		// Die von der Fenstergre abhngigen Attribute werden gesetzt
		// -1 = nicht gesetzt wird am anfang von zeichnen() abgefragt
		pixel_maxx = -1;
		pixel_maxy = -1;

		// es gibt am anfang keine "alte" Position der Maus
		// --> -1 = nicht gesetzt
		mouse_alt_x = -1;
		mouse_alt_y = -1;
		// Der Parser wird geholt
		p = Parser.getInstance();
		// Cursor zum verschieben des Schaubildes wird gesetzt..
		zeiger_verschieben = new Cursor(java.awt.Cursor.HAND_CURSOR);
		// Cursor normal
		zeiger_normal = new Cursor(java.awt.Cursor.DEFAULT_CURSOR);
		// Standard 1 fr maximale genauigkeit
		funktionGenauigkeit = 1;
		// man darf das schaubild mit der maus verschiebe = true
		mausverschieben=true;
		// Standard ist kein spiel aktiv
		spiel=false;
		// Standard 120 pixel (x)
		tipgroesse = 80;
		// Dicke der Funktion = 1
		funktionsdicke=1;
		//beschriftungen initialisieren
		beschriftungen = new ArrayList();
		// Antialising, standard aus
		antialising = RenderingHints.VALUE_ANTIALIAS_OFF;
		MyListener myListener = new MyListener();
        addMouseListener(myListener);
        addMouseMotionListener(myListener);

		// Das OptionenMenu wird geladen
		initMenu();
		// ein Panel fr die Farbauswahl wird gesetzt
        fpanel = new JPanel();
	}

	
	/** Gibt die Pixelstelle (x-Pixel) fr eine Stelle im
	* Koordinatensystem an
	* 
	* @return pixelstelle ist die Pixelstelle fr die bergebene "reale" Stelle
	*/
	private int holePixelStelle(double stelle){
		double einheit = ((double)pixel_maxx)/(ende_x - anfang_x);
		int pixelstelle = (int)(einheit*(stelle-anfang_x));
		return pixelstelle;
	}
	
	/** Gibt den Pixelwert (y-Pixel) fr einen Wert im
	* Koordinatensystem an
	* 
	* @return pixelwert ist der Pixelwert fr drn bergebenen "realen" Wert
	* 
	*/
	private int holePixelWert(double wert){
		double einheit = ((double)pixel_maxy)/(ende_y - anfang_y);
		int pixelwert = pixel_maxy - (int)(einheit*(wert-anfang_y));
		return pixelwert;
	}
	
	/** Der Parser, den das Schaubild benutzt kann bergeben werden 
	 * 
	 * @return p ist der Parser
	 */
	public Parser holeParser(){
		return p;
	}
	
	/** Dies ist die Hauptzeichen-Methode, in ihr werden alle Dinge gezeichnet
	 */
	public void zeichne(){
		g2d = (Graphics2D)getGraphics();
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
		requestFocus();
		// Zu Beginn setzen
		if(pixel_maxy == -1 || pixel_maxx == -1) {
			pixel_maxy = getHeight();
			pixel_maxx = getWidth();
			// Die Anfangswerte ( und die Endwerte ) des Koordinatensystems 
			//werden gesetzt
			anfang_x = -((pixel_maxx / 2) / normaleinheit);
			ende_x = ((pixel_maxx / 2) / normaleinheit);
			anfang_y = -((pixel_maxy / 2) / normaleinheit);
			ende_y = ((pixel_maxy / 2) / normaleinheit);			
		}
		
		auswischen();
		zeichne_Gitter();
		zeichne_Xachse();
		zeichne_Yachse();
		//Hier die Punkte:
		if(punkte_sicher!=null){
			Iterator iter = punkte_sicher.iterator();
			while(iter.hasNext()){
				Punkt punkt = (Punkt)iter.next();
				zeichnePunkt(punkt);
			}
		}
		//Hier die Funktionen:
		if(funktionen_sicher!=null)
		{
			Iterator iter = funktionen_sicher.iterator();
			while(iter.hasNext()){
				Funktion funk = (Funktion)iter.next();
				if(funk.istSichtbar()&& !funk.holeFunktionsTerm().equals("")) zeichneFunktion(funk);
				//Ableitungen
				if(funk.istSichtbar()&& funk.holeAbleitungen()!= null){
					Iterator ita = funk.holeAbleitungen().iterator();
					while(ita.hasNext()){
						zeichneAbleitung(funk,Integer.parseInt((String)ita.next()));
					}
				}
			}
		}
		zeichneBeschriftungen();
	}
	
	/** Zeichnet die x-Achse und beschrifftet diese passend */
	private void zeichne_Xachse(){
		g2d.setColor(achsenfarbe);
		int pixel_nullwert = holePixelWert(0.0);
		int pixel_i;
		// zunchst einmal berprfen ob die x-Achse dargestellt werden muss
		if(pixel_nullwert > 0 && pixel_nullwert < pixel_maxy) {
			g2d.drawLine (0, pixel_nullwert, pixel_maxx, pixel_nullwert);
			

			// Die x-achse im Bereich > 0 wird skaliert falls ntig
			if(ende_x > 0){
				// der startpunkt der Skalierung in 2 Fllen ( nur positiv 
				//oder gemischt)
				double start = 0.0 + vergr_x;
				if(anfang_x >= 0) start = anfang_x + (vergr_x-(anfang_x % vergr_x));
	
				for(double i = start ; i<ende_x; i += vergr_x){
					pixel_i = holePixelStelle(i);
					g2d.setColor(achsenfarbe);
					g2d.drawLine(pixel_i,pixel_nullwert - 3, pixel_i, pixel_nullwert + 3);
					g2d.drawString(Double.toString(Math.round(i*10000.0)/10000.0),pixel_i - 8,pixel_nullwert + 15 );			
				}
			}		
				
			// Die x-achse im Bereich < 0 wird skaliert falls ntig
			if(anfang_x < 0){
				// der startpunkt der Skalierung in 2 Fllen ( nur negativ oder 
				//gemischt)
				double start = 0.0 - vergr_x;
				if(ende_x <= 0) start = ende_x - (vergr_x+(ende_x % vergr_x));
	
				for(double i = start; i>anfang_x; i -= vergr_x){
					pixel_i = holePixelStelle(i);
					g2d.setColor(achsenfarbe);
					g2d.drawLine(pixel_i,pixel_nullwert - 3, pixel_i, pixel_nullwert + 3);
					g2d.drawString(Double.toString(Math.round(i*10000.0)/10000.0),pixel_i - 12,pixel_nullwert + 15 );			
				}
			}
			
		}
	}
	
	/** Zeichnet die y-Achse und beschrifftet diese passend */
	private void zeichne_Yachse(){
		g2d.setColor(achsenfarbe);
		int pixel_nullstelle = holePixelStelle(0.0);
		int pixel_i;
		// zunchst einmal berprfen ob die x-Achse dargestellt werden muss
		if(pixel_nullstelle > 0 && pixel_nullstelle < pixel_maxx) {
			g2d.drawLine (pixel_nullstelle, 0, pixel_nullstelle, pixel_maxy);
			

			// Die y-achse im Bereich > 0 wird skaliert falls ntig
			if(ende_y > 0){
				// der startpunkt der Skalierung in 2 Fllen ( nur positiv 
				//oder gemischt)
				double start = 0.0 + vergr_y;
				if(anfang_y >= 0) start = anfang_y + (vergr_y-(anfang_y % vergr_y));
	
				for(double i = start; i<ende_y; i += vergr_y){
					pixel_i = holePixelWert(i);
					g2d.setColor(achsenfarbe);
					g2d.drawLine(pixel_nullstelle - 3, pixel_i, pixel_nullstelle + 3, pixel_i);
					g2d.drawString(Double.toString(Math.round(i*1000.0)/1000.0),pixel_nullstelle + 5, pixel_i+4 );			
				}
			}		
				
			// Die y-achse im Bereich < 0 wird skaliert falls ntig
			if(anfang_y < 0){
				// der startpunkt der Skalierung in 2 Fllen ( nur negativ 
				//oder gemischt)
				double start = 0.0 - vergr_y;
				if(ende_y <= 0) start = ende_y -(vergr_y+(ende_y % vergr_y));
	
				for(double i = start; i>anfang_y; i -= vergr_y){
					pixel_i = holePixelWert(i);
					g2d.setColor(achsenfarbe);
					g2d.drawLine(pixel_nullstelle - 3, pixel_i, pixel_nullstelle + 3, pixel_i);
					g2d.drawString(Double.toString(Math.round(i*1000.0)/1000.0),pixel_nullstelle + 9, pixel_i+4 );			
				}
			}
			
		}
	}
	
	/** Zeichnet das Gitter fr das Koordinatensystem */
	private void zeichne_Gitter(){
		double start_x = anfang_x - ( vergr_x + ( anfang_x % vergr_x ));
		double start_y = anfang_y - ( vergr_y + ( anfang_y % vergr_y ));
		g2d.setColor(gitterfarbe);
		for(double i = start_x;i < ende_x;i += vergr_x/2){
			g2d.drawLine(holePixelStelle(i), 0, holePixelStelle(i), pixel_maxy);
		}
		for(double i = start_y;i < ende_y;i += vergr_y/2){
			g2d.drawLine(0, holePixelWert(i), pixel_maxx, holePixelWert(i));
		}	
	}
	

	/** Wischt die ZeichenOberflaeche ab.
	* Diese Methode lscht alles, was zur Zeit im Zeichenbereich angezeigt 
	* wird
	*/
	private void auswischen(){
		//g2d = getGraphics();
		g2d.setColor(hintergrundfarbe);
		g2d.fillRect(0,0,pixel_maxx,pixel_maxy);	
	}
	/** Diese Funktion dient dem Neusetzen der Fenstergre
	 * falls dieses verzogen wird.
	 */
	public void aktualisiere(){
		// Neu setzen der Begrenzungen des Schaubildes ( falls das Fenster 
		//verndert wird )
		if(pixel_maxx != -1 && pixel_maxy != -1 && spiel==false){
			int pixel_maxx_diff = getWidth() - pixel_maxx;
			int pixel_maxy_diff = getHeight()- pixel_maxy;
			double einheit_x = (ende_x - anfang_x)/((double)pixel_maxx);
			double einheit_y = (ende_y - anfang_y)/((double)pixel_maxy);
			//Zum Verhindern von Fehlern beim langsamen Ziehen des Seperators
		 	anfang_x = anfang_x - (pixel_maxx_diff/2.0)*einheit_x;
			ende_x = ende_x + ( pixel_maxx_diff/2.0)*einheit_x;
			anfang_y = anfang_y - (pixel_maxy_diff/2.0)*einheit_y;
			ende_y = ende_y + (pixel_maxy_diff/2.0)*einheit_y;
			pixel_maxx = getWidth();
			pixel_maxy = getHeight();
		}
		// Luft ein spiel so soll das Schaubild gestreckt werden
		if(spiel==true){
			pixel_maxx = getWidth();
			pixel_maxy = getHeight();
		}
		zeichne();
	}
	
	/** Diese Funktion dient der Darstellung von Ableitungen
	 * @param funk ist die zu zeichnende Funktion
	 */

	private void zeichneAbleitung(Funktion funk,int grad){
		String funktionsterm = funk.holeFunktionsTerm();
		double intervall = (ende_x - anfang_x) / pixel_maxx;
		Collection punkte_sicher = p.gibWerteAbgeleitet(funktionsterm, anfang_x, intervall*funktionGenauigkeit, ende_x, platzSpeicher, grad);
		Color farbe = funk.holeFarbe();
		int alpha=255;
		for(int i=0; i <= grad; i++){
			if(alpha>140)alpha-= 40;
		}
		farbe = new Color(farbe.getRed(),farbe.getGreen(),farbe.getBlue(),alpha);
		zeichneFunktion(farbe, punkte_sicher);
	}
	
	/** Diese Funktion dient der berage einer Funktion von dem Schaubild an
	 * den Parser. Die Werte werden gespeichert und eine weiter zeichen 
	 * funktion aufgerufen 
	 * @param funk ist die zu zeichnende Funktion
	 */
	

	private void zeichneFunktion(Funktion funk){
		String funktionsterm = funk.holeFunktionsTerm();
		double intervall = (ende_x - anfang_x) / pixel_maxx;
		Collection punkte_sicher = p.gibWerte(funktionsterm, anfang_x, intervall*funktionGenauigkeit, ende_x, platzSpeicher);
		zeichneFunktion(funk.holeFarbe(), punkte_sicher);
	}
	
	/** Zeichnet eine bestimmte Funktion.
	* Eine Funktion mit einer bestimmten ID, die zur Oberflche hinzugefgt 
	* wurde, kann mit diesem Befehl gezielt gezeichnet werden.
	* @param	farbe ist die Farbe in der die Funktion gezeichnet wird
	* @param	punkte ist eine Collection der x/y Koordinaten bergeben von 
	* 			dem Parser
	*/
	
	private void zeichneFunktion(Color farbe, Collection punkte){			
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, antialising);
		final BasicStroke duenn	= new BasicStroke(1.0f); 
		final BasicStroke mittel= new BasicStroke(2.0f); 
		final BasicStroke dick	= new BasicStroke(3.0f);
		if(funktionsdicke==1)g2d.setStroke(duenn);
		if(funktionsdicke==2)g2d.setStroke(mittel);
		if(funktionsdicke==3)g2d.setStroke(dick);
	 	int x,y,xalt,yalt;
	 	xalt = -1;
	 	yalt = -1;
		g2d.setColor(farbe);
	 	Iterator iter = punkte.iterator();
		while(iter.hasNext()){
			Punkt2d punkt = (Punkt2d)iter.next();
			x = holePixelStelle(punkt.holeX());
			y = holePixelWert(punkt.holeY());
			if(xalt!= -1 && yalt!=-1 && (yalt-y) < pixel_maxy/2 ){
				g2d.drawLine(xalt,yalt,x,y);
			}
			xalt = x;
			yalt = y;
		}
		g2d.setStroke(duenn); 
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
	}

	
	/** Die zu zeichnenden Funktionen werden als Collection bergeben
	 * @param Eine Collection in denen die Funktionen enthalten sind
	 */
	public void gebeFunktionen(Collection funktionen){
			funktionen_sicher = funktionen;
	}
	
	/** Die Funktionen die das Schaubild momentan zeichnet werden abgerufen
	 * @return Eine Collection aller Funktionen die gezeichnet werden
	 */
	public Collection holeFunktionen(){
		return funktionen_sicher;
	}

	/** Die zu zeichnenden Punkte werden als Collection bergeben
	 * @param Eine Collection der Punkte, die gezeichnet werden sollen
	 */
	public void gebePunkte(Collection punkte){
			punkte_sicher = punkte;
	}
		
	public void loescheFunktion(String funkterm){
		Iterator iter = funktionen_sicher.iterator();
		while(iter.hasNext()){
			Funktion funk = (Funktion)iter.next();
			if(funk.holeFunktionsTerm().equals(funkterm)){
				funktionen_sicher.remove(funk);
			}
		}
	}

	public int holePixelX(){
		return getWidth();
	}
	
	/** Zeichnet einen Punkt.
	*	Der radius wird an die x-achse angelegt.
	*/
	private void zeichnePunkt(Punkt punkt){
		int x = holePixelStelle(punkt.holeX());
		int y = holePixelWert(punkt.holeY());
		g2d.setColor(punkt.holeFarbe());
		
		double r = punkt.holeRadius();
		double einheit_x = (ende_x - anfang_x)/((double)pixel_maxx);
		double einheit_y = (ende_y - anfang_y)/((double)pixel_maxy);
		if(r==0){
			 r = einheit_x;
		}
		int radiusx = (int)(r/einheit_x);
		int radiusy = (int)(r/einheit_y);
		g2d.fillOval(x-radiusx,y-radiusy,2*radiusx,2*radiusy);	
	}

	public void setzeAnzeigeAnMaus(boolean eingeschaltet){
		anzeigeanmaus = eingeschaltet;		
	}
	
	public void gebeBeschriftung(Beschriftung b){
		beschriftungen.add(b);
	}
	
	public void zeichneBeschriftungen(){
		if(beschriftungen!=null)
		{
			Iterator iter = beschriftungen.iterator();
			while(iter.hasNext()){
				Beschriftung beschr = (Beschriftung)iter.next();
				zeichneBeschriftung(beschr);
			}
		}
	}
	
	public void zeichneBeschriftung(Beschriftung beschr){
		g2d.setColor(Color.black);
		int xb = holePixelStelle(beschr.holeX());
		int yb = holePixelWert(beschr.holeY());
		g2d.setColor(beschr.holeFarbe());
		g2d.drawString(beschr.holeBeschriftung(), xb,yb);
		
	}
	
	private double setze_Vergroesserung(int stufe){
		double vergroesserungsfaktor = 1;
		double mal_normal = 2.0;
		double mal_dritte = 2.5;

		if(stufe < 0){
			stufe = -stufe;
			mal_normal = 1.0/2.0;
			mal_dritte = 1.0/2.5;
		}
		
		for(int i=1; i <= stufe; i++) {
			if((i % 3)==0) {
				vergroesserungsfaktor = vergroesserungsfaktor * mal_dritte;
			}
			else {
				vergroesserungsfaktor = vergroesserungsfaktor * mal_normal;
			}
		}
		return vergroesserungsfaktor;
	}
	
	/** Setze Vergrerungsstufe auf der x-Achse.
	* So kann kann man die x-Achse seperat vergrern oder verkleinern
	* @param	xstufe ist der Faktor, der die x-Achse staucht oder streckt
	*/	
	public void setzeVergroesserungsStufeX(int xstufe){
		vergr_speicher_x = xstufe;
		double vergr_neu_x = setze_Vergroesserung(xstufe);
		
		double lang = ende_x - anfang_x;
		double mitte = anfang_x + lang/2;
		anfang_x = 	mitte - (lang/2) * vergr_neu_x / vergr_x;
		ende_x = 	mitte + (lang/2) * vergr_neu_x / vergr_x;
		
		vergr_x = vergr_neu_x;
	}
	/** Setze Vergrerungsstufe auf der y-Achse.
	* So kann kann man die y-Achse seperat vergrern oder verkleinern
	* @param	ystufe ist der Faktor, der die y-Achse staucht oder streckt
	*/
	public void setzeVergroesserungsStufeY(int ystufe){
		vergr_speicher_y = ystufe;
		double vergr_neu_y = setze_Vergroesserung(ystufe);
		
		double lang = ende_y - anfang_y;
		double mitte = anfang_y + lang/2;
		anfang_y = 	mitte - (lang/2) * vergr_neu_y / vergr_y;
		ende_y = 	mitte + (lang/2) * vergr_neu_y / vergr_y;
		
		vergr_y = vergr_neu_y;
	}
	/** Holt die Vergrerungsstufe auf der x-Achse.
	* @return	Vergrerungsfaktor auf der x-Achse
	*/
	public int holeVergroesserungsStufeX(){
		return vergr_speicher_x;
	}
	/** Holt die Vergrerungsstufe auf der y-Achse.
	* @return	Vergrerungsfaktor auf der y-Achse
	*/
	public int holeVergroesserungsStufeY(){
		return vergr_speicher_y;
	}
	/** Setzt die Werte so um, dass die Spiele fehlerfrei dargestellt werden */
	public void setzeSpiel(double anfang_x, double ende_x,double anfang_y,double ende_y){
		this.anfang_x = anfang_x;
		this.ende_x = ende_x;
		this.anfang_y = anfang_y;
		this.ende_y = ende_y;
		mausverschieben=false;
		spiel=true;
	}
	
	/** Zeigt die "realen" Koordinaten der Maus an
	 * 
	 * @param x die x-pixel koordinate der Maus
	 * @param y die y-pixel koordinate der Maus
	 */
	private void aktualisiereTip(int x,int y){
		double einheit_x = ((double)pixel_maxx)/(ende_x - anfang_x);
		double einheit_y = ((double)pixel_maxy)/(ende_y - anfang_y);
		double real_x = Math.round( (anfang_x + (double)x / einheit_x)*100 ) ;
		double real_y = Math.round( (anfang_y + (double)(pixel_maxy - y) / einheit_y)*100 );
		String text = (real_x/100 + " | " + real_y/100);
		g2d.setColor(Color.blue);
		g2d.drawRect(0,0,tipgroesse,17);
		g2d.setColor(hintergrundfarbe);
		g2d.fillRect(0,0,tipgroesse,16);
		g2d.setColor(anzeigeanmausfarbe);
		g2d.drawString(text,5,14);
	}
	
	/** Das PopupMenue wird initialisiert.
	 * Dies geschieht im Konstruktor und wurde aus Grnden der 
	 * bersichtlichkeitausgegliedert
	 */
	private void initMenu(){

		mbar = new JPopupMenu("Optionen");
		menuItem = new JMenuItem("Ursprung zentrieren");
		menuItem.addActionListener(this);
		menuItem.setActionCommand("zentriere");
		mbar.add(menuItem);
		
		cbMenuItem = new JCheckBoxMenuItem("Maus-Koordinaten");
		cbMenuItem.addActionListener(this);
		cbMenuItem.setActionCommand("koords");
		mbar.add(cbMenuItem);
		
		cbMenuItem = new JCheckBoxMenuItem("Antialising");
		cbMenuItem.addActionListener(this);
		cbMenuItem.setActionCommand("antialising");
		mbar.add(cbMenuItem);
		mbar.addSeparator();
		
		menuItem = new JMenuItem("Hintergrundfarbe ndern");
		menuItem.addActionListener(this);
		menuItem.setActionCommand("hinter");
		mbar.add(menuItem);
		
		menuItem = new JMenuItem("Gitterfarbe ndern");
		menuItem.addActionListener(this);
		menuItem.setActionCommand("gitter");
		mbar.add(menuItem);
		
		menuItem = new JMenuItem("Achsenfarbe ndern");
		menuItem.addActionListener(this);
		menuItem.setActionCommand("achsen");
		mbar.add(menuItem);
		mbar.addSeparator();
		
		/*  Das 1. Untermenu */
			submenu = new JMenu("Qualitt der Anzeige");
			ButtonGroup groupQuali = new ButtonGroup();
			
			rbMenuItem = new JRadioButtonMenuItem("0,5 -  Qualitt");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("quali0.5");
			groupQuali.add(rbMenuItem);
			submenu.add(rbMenuItem);
			
			rbMenuItem = new JRadioButtonMenuItem("1 - Optimale Qualitt");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("quali1");
			rbMenuItem.setSelected(true);
			groupQuali.add(rbMenuItem);
			submenu.add(rbMenuItem);
	
			rbMenuItem = new JRadioButtonMenuItem("3 - mittlere Qualitt");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("quali3");
			groupQuali.add(rbMenuItem);
			submenu.add(rbMenuItem);
				
			rbMenuItem = new JRadioButtonMenuItem("5 - schlechte Qualitt");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("quali5");
			groupQuali.add(rbMenuItem);
			submenu.add(rbMenuItem);
			
			rbMenuItem = new JRadioButtonMenuItem("10 - schlechteste Qualitt");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("quali10");
			groupQuali.add(rbMenuItem);
			submenu.add(rbMenuItem);
			
			mbar.add(submenu);
		/* 1. ENDE */
			
		/*  Das 2. Untermenu */
			submenu = new JMenu("Dicke der Graphen");
			ButtonGroup groupDicke = new ButtonGroup();
			
			rbMenuItem = new JRadioButtonMenuItem("1 - duenn");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("dick1");
			rbMenuItem.setSelected(true);
			groupDicke.add(rbMenuItem);
			submenu.add(rbMenuItem);
			
			rbMenuItem = new JRadioButtonMenuItem("2 - mittel");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("dick2");
			groupDicke.add(rbMenuItem);
			submenu.add(rbMenuItem);
			
			rbMenuItem = new JRadioButtonMenuItem("3 - dick");
			rbMenuItem.addActionListener(this);
			rbMenuItem.setActionCommand("dick3");
			groupDicke.add(rbMenuItem);
			submenu.add(rbMenuItem);
			
			mbar.add(submenu);
		/* 2. ENDE */
			
		mbar.addSeparator();
		
		menuItem = new JMenuItem("Beschriftung einfuegen");
		menuItem.addActionListener(this);
		menuItem.setActionCommand("beschriftungeinfuegen");
		mbar.add(menuItem);
		
		/*  Das 3. Untermenu */
			submenu = new JMenu("Ableitungen");
			mbar.add(submenu);
			ableitungposi = mbar.getComponentIndex(submenu);
		/* 3. ENDE */
			
		/*  Das 4. Untermenu */
			submenu = new JMenu("Beschriftungen");
			mbar.add(submenu);
		/*4. ENDE */
			
		mbar.setVisible(false);
	}
	
	private void aktualisiereMenu(){
		int i = 1;
		int n;
		
		mbar.remove(ableitungposi); // Ableitungen entfernen
		mbar.remove(ableitungposi); // Beschriftung entfernen ( liegt jetzt auf der gleichen stelle )
		
		submenu = new JMenu("Ableitungen");
		if(funktionen_sicher.size()!=0)
		{
			Iterator iter = funktionen_sicher.iterator();

			while(iter.hasNext()){
				boolean eins=false,zwei=false,drei=false;
				Funktion funk = (Funktion)iter.next();
				if(funk.istSichtbar()){
					Iterator ita = funk.holeAbleitungen().iterator();
					while(ita.hasNext()){
						String s = (String)ita.next();
						if(s.equals("1")) eins=true;
						if(s.equals("2")) zwei=true;
						if(s.equals("3")) drei=true;
					}
					ssubmenu = new JMenu(i + " - " + funk.holeFunktionsTerm());
					ssubmenu.setForeground(funk.holeFarbe());
					
					cbMenuItem = new JCheckBoxMenuItem("1. Ableitung");
					cbMenuItem.setState(eins);
					cbMenuItem.addActionListener(this);
					cbMenuItem.setActionCommand(i + "ableitung" + 1);
					ssubmenu.add(cbMenuItem);
						
					cbMenuItem = new JCheckBoxMenuItem("2. Ableitung");
					cbMenuItem.setState(zwei);
					cbMenuItem.addActionListener(this);
					cbMenuItem.setActionCommand(i + "ableitung" + 2);
					ssubmenu.add(cbMenuItem);
					
					cbMenuItem = new JCheckBoxMenuItem("3. Ableitung");
					cbMenuItem.setState(drei);
					cbMenuItem.addActionListener(this);
					cbMenuItem.setActionCommand(i + "ableitung" + 3);
					ssubmenu.add(cbMenuItem);
					
					ita = funk.holeAbleitungen().iterator();
					while(ita.hasNext()){
						int abl  = Integer.parseInt((String)ita.next());
						if(abl>3){
							cbMenuItem = new JCheckBoxMenuItem(abl + ". Ableitung");
							cbMenuItem.setState(true);
							cbMenuItem.addActionListener(this);
							cbMenuItem.setActionCommand(i + "ableitung" + abl);
							ssubmenu.add(cbMenuItem);
						}
					}
					
					txt = new JTextField("4");
					txt.addActionListener(this);
					txt.setActionCommand(i+"ableitfeld");
					ssubmenu.add(txt);
					
					submenu.add(ssubmenu);
				}
			i++;
			}
		}
		else {
			la = new JLabel("Keine Funktionen");
			la.setForeground(Color.red);
			submenu.add(la);			
		}
		mbar.add(submenu);
		ableitungposi = mbar.getComponentIndex(submenu);
		// Ableitungen fertig, jetzt zu den Beschriftungen
		
		submenu = new JMenu("Beschriftungen");
		i = 1;
		if(beschriftungen.size()!=0)
		{
			Iterator iter = beschriftungen.iterator();
			while(iter.hasNext()){
				Beschriftung b = (Beschriftung)iter.next();
			
				ssubmenu = new JMenu(i +" - " +  b.holeBeschriftung());
				
				menuItem = new JMenuItem("loeschen");
				menuItem.addActionListener(this);
				menuItem.setActionCommand(i + "beschriftungloeschen");
				ssubmenu.add(menuItem);
				
				ssubmenu.addSeparator();
				
				menuItem = new JMenuItem("Farbe aendern");
				menuItem.addActionListener(this);
				menuItem.setActionCommand(i + "beschriftungfarbe");
				ssubmenu.add(menuItem);
							
				menuItem = new JMenuItem("verschieben");
				menuItem.addActionListener(this);
				menuItem.setActionCommand(i + "beschriftungverschieben");
				ssubmenu.add(menuItem);
				
				ssubmenu.addSeparator();
								
				menuItem = new JMenuItem("Text aendern:");
				ssubmenu.add(menuItem);
				
				txt = new JTextField(b.holeBeschriftung());
				txt.addActionListener(this);
				txt.setActionCommand(i + "beschriftungtext");
				ssubmenu.add(txt);
				
				submenu.add(ssubmenu);
				i++;
			}
		}
		else {
			la = new JLabel("Keine Beschriftungen");
			la.setForeground(Color.red);
			submenu.add(la);			
		}
		mbar.add(submenu);
		// Beschriftung fertig
		
		
	}
	
	
	/** Dient dem Aufrufen des Dialogs
	 * zum ndern der Farbe
	 * @param Farbe ist die Farbe die momentan gesetzt ist
	 * @return die farbe die gesetzt wird ( durch den Dialog )
	 */
	private Color aendereFarbe(Color Farbe){
		final JColorChooser farbauswaehler = new JColorChooser();
		ausgewaehlteFarbe = Farbe;
		ActionListener okListener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (e.getActionCommand().equals("OK")){
					ausgewaehlteFarbe = farbauswaehler.getColor();
				}
			}
		};
		JDialog dialog = JColorChooser.createDialog(fpanel,"Farbe whlen:",true,farbauswaehler,okListener,null);
		dialog.setVisible(true);
		return ausgewaehlteFarbe;
	}
	

	/** Diese Funktion dient dem setzen einer Ableitung.
	 * Sie behandelt nicht nur die ersten 3 Ableitungen um spter auch mehr Ableitungen zu bieten.
	 * @param funknummer die Nummer der Funktion ( Reihenfolge der Collection funktionen_sicher
	 * @param ableitung die Nummer der Ableitung ( Der Grad der Ableitung )
	 */
	public void setzeAbleitung(int funknummer, int ableitung){
		Iterator iter = funktionen_sicher.iterator();
		boolean geloescht=false;
		int i = 1;
		while(iter.hasNext()){
			Funktion funk =(Funktion)iter.next();
			if(funknummer==i){
				ArrayList ableitungen = funk.holeAbleitungen();
				if(ableitungen!=null){
					Iterator ita = ableitungen.iterator();
					while(ita.hasNext() && !geloescht){
						if(((String)ita.next()).equals(""+ableitung)){
							geloescht = true;
							System.out.println("Schaubild --> Ableitung " + ableitung + " der Funktion " + funk.holeFunktionsTerm() + " geloescht");
							ableitungen.remove(ableitung+"");
						}
						if(geloescht){
							//ableitungen.remove(ableitung+"");
						}
					}
				}
				if(!geloescht){
					ableitungen.add(""+ableitung);
				}
				//System.out.println("Ableitungen gesetzt");
				break;
			}
			i++;
		}
	}
	
	/** Dient der Verwaltung aller Buttons und sonstiger Menuelemente */
	public void actionPerformed(ActionEvent e){
		String cmd = e.getActionCommand();
		if(cmd=="zentriere"){
			System.out.println("Schaubild --> Urpsrung zentrieren");
			double a_x = -(ende_x - anfang_x)/2;
			ende_x = (ende_x - anfang_x)/2;
			anfang_x = a_x;
			double a_y = -(ende_y - anfang_y)/2;
			ende_y = (ende_y - anfang_y)/2;
			anfang_y = a_y;
		}
		else if(cmd=="hinter"){
			hintergrundfarbe = aendereFarbe(hintergrundfarbe);
			System.out.println("Schaubild --> Setze Hintergrundfarbe: " + hintergrundfarbe);
		}
		else if(cmd=="gitter"){
			gitterfarbe = aendereFarbe(gitterfarbe);
			System.out.println("Schaubild --> Setze Gitterfarbe: " + hintergrundfarbe);
		}
		else if(cmd=="achsen"){
			achsenfarbe = aendereFarbe(achsenfarbe);
			System.out.println("Schaubild --> Setze Achsenfarbe: " + hintergrundfarbe);
		}
		else if(cmd.contains("quali")){
			String s = cmd;
			s = s.replace("quali", "");
			funktionGenauigkeit = Double.parseDouble(s);
			System.out.println("Schaubild --> Genauigkeit gesetzt:" + funktionGenauigkeit);
		}
		else if(cmd == "koords"){
			JCheckBoxMenuItem cb = (JCheckBoxMenuItem)e.getSource();
			setzeAnzeigeAnMaus(cb.getState());
			System.out.println("Schaubild --> Zeige Infos An/Aus");
		}	
		else if(cmd =="antialising"){
			if(antialising == RenderingHints.VALUE_ANTIALIAS_OFF){
				antialising = RenderingHints.VALUE_ANTIALIAS_ON;
			}
			else {
				antialising = RenderingHints.VALUE_ANTIALIAS_OFF;
			}
		}
		else if(cmd.contains("dick")){
			String s = cmd;
			s = s.replace("dick","");
			int dicke = Integer.parseInt(s);
			funktionsdicke = dicke;
			System.out.println("Schaubild --> Dicke ausgewaehlt: " +dicke);
		}
		else if(cmd.contains("ableitung")){
			String s = cmd;
			String teile[] = s.split("ableitung");
			int funktion = Integer.parseInt(teile[0]);
			int ableitung = Integer.parseInt(teile[1]);
			System.out.println("Schaubild --> Funktion ausgewaehlt:" + funktion + " Ableitung : " + ableitung);
			setzeAbleitung(funktion,ableitung);
		}
		else if(cmd.contains("ableitfeld")){
			String s = cmd;
			s = s.replace("ableitfeld","");
			JTextField source = (JTextField)(e.getSource());
			int funktion = Integer.parseInt(s);
			int ableitung = Integer.parseInt(source.getText());
			System.out.println("Schaubild --> Funktion ausgewaehlt:" + funktion + " Ableitung : " + ableitung);
			setzeAbleitung(funktion,ableitung);
		}
		else if(cmd=="beschriftungeinfuegen"){
			gebeBeschriftung(new Beschriftung("Neue Beschriftung", Color.red, (ende_x + anfang_x)/2, (ende_y + anfang_y)/2));
			System.out.println("Schaubild --> Neue Beschriftung hinzugefuegt");
		}
		else if(cmd.contains("beschriftungfarbe")){
			String s = cmd;
			s = s.replace("beschriftungfarbe","");
			int beschriftung = Integer.parseInt(s) - 1;
			Beschriftung b = (Beschriftung)beschriftungen.get(beschriftung);
			b.setzeFarbe(aendereFarbe(b.holeFarbe()));
			beschriftungen.set(beschriftung, b);
			System.out.println("Schaubild --> Beschriftung "+ (beschriftung+1) +":Farbe geaendert");
		}
		else if(cmd.contains("beschriftungtext")){
			String s = cmd;
			s = s.replace("beschriftungtext","");
			JTextField source = (JTextField)(e.getSource());
			int beschriftung = Integer.parseInt(s)-1;
			Beschriftung b = (Beschriftung)beschriftungen.get(beschriftung);
			b.setzeBeschriftung(source.getText());
			beschriftungen.set(beschriftung, b);
			System.out.println("Schaubild --> Beschriftung "+(beschriftung+1) +":Text geaendert zu: " +source.getText());
		}
		else if(cmd.contains("beschriftungloeschen")){
			String s = cmd;
			s = s.replace("beschriftungloeschen","");
			int beschriftung = Integer.parseInt(s) - 1;
			beschriftungen.remove(beschriftung);
			System.out.println("Schaubild --> Beschriftung "+ (beschriftung+1) + " geloescht");
		}
		else if(cmd.contains("beschriftungverschieben")){
			String s = cmd;
			s = s.replace("beschriftungverschieben","");
			int beschriftung = Integer.parseInt(s) - 1;
			beschriftungv = beschriftung + 1;
			System.out.println("Schaubild --> Beschriftung "+ (beschriftung+1) + " verschieben!");
		}
		aktualisiere();
	}
	

	
	/** Diese Klasse benutzt MouseInputAdapter
	 * um sowohl mouse events, als auch mouse-motion events
	 * bearbeiten zu knnen
	 */
    private class MyListener extends MouseInputAdapter {
    	public void mouseReleased(MouseEvent e){
			int x=e.getX();
			int y=e.getY();
    		if(e.isPopupTrigger() && !spiel) {
    			aktualisiereMenu();
    			mbar.show(e.getComponent(), e.getX(), e.getY());
    			//System.out.println("Schaubild --> Menue goeffnet: ");
       		}
    		if(anzeigeanmaus == true) {		
    			aktualisiereTip(x,y);
    		}
    	}
    	
       	public void mousePressed(MouseEvent e){
   			int x=e.getX();
			int y=e.getY();
    		if(e.isPopupTrigger() && !spiel) {
    			aktualisiereMenu();
    			mbar.show(e.getComponent(), e.getX(), e.getY());
    			//System.out.println("Schaubild --> Menue goeffnet: ");
       		}
    		if(anzeigeanmaus == true) {		
    			aktualisiereTip(x,y);
    		}
    		if(beschriftungv!=0){
    			beschriftungv = 0;
    		}
			zeichne();
    	}

    	/** Maus wird gezogen. 
    	Diese Funktion steuert die Verschiebung des Graphen auf der 
    	Zeichenflaeche.  Es wird jeweils die Differenz von der alten Position 
    	der Maus bestimmt und im Verhaeltnis des Zooms auf die tatsaechliche 
    	Verschiebung umgerechnet (so kann man komfortabel auf der Leinwand 
    	"scrollen"). 
    	@param		e ist MouseEvent */
    	
    	public void mouseDragged (MouseEvent e) {
    		if(mausverschieben==true){
    			int x=e.getX();
    			int y=e.getY();
    			if(mouse_alt_x == -1 || mouse_alt_y == -1){
    				mouse_alt_x = x;
    				mouse_alt_y = y;
    			}
    			
    			double einheit_x = ((double)pixel_maxx)/(ende_x - anfang_x);	
    			double einheit_y = ((double)pixel_maxy)/(ende_y - anfang_y);
    			double real_x = (double)(mouse_alt_x - x) / einheit_x;
    			double real_y = (double)((pixel_maxy - mouse_alt_y) - (pixel_maxy -y )) / einheit_y;
    		
    			anfang_x += real_x;
    			ende_x   += real_x;
    			anfang_y += real_y;
    			ende_y   += real_y;
    		
    			mouse_alt_x = x;
    			mouse_alt_y = y;
    			zeichne();
    			setCursor(zeiger_verschieben);
    		}
    	}

    	/** Maus wird bewegt. 
    	*	Diese Funktion steuert die Bewegung der Maus auf der Zeichenflaeche.
    	*	Dies ist notwendig um das Bewegen des Schaubildes zu ermglichen, 
    	*	des weitern wird die Position der Maus wenn aktiviert angezeigt.	
    	*	@param		e ist MouseEvent */
    	
    	public void mouseMoved (MouseEvent e) {
    		requestFocus();
    		int x=e.getX();
    		int y=e.getY();	
    		mouse_alt_x = x;
    		mouse_alt_y = y;
    		if(getCursor() != zeiger_normal) setCursor(zeiger_normal);
    		// Wenn anzeigeanmaus wahr ist wird die Position der Maus oben links gezeigt
    		if(anzeigeanmaus == true) {		
    			aktualisiereTip(x,y);
    		}
    		if(beschriftungv!=0){
    			double einheit_x = ((double)pixel_maxx)/(ende_x - anfang_x);
    			double einheit_y = ((double)pixel_maxy)/(ende_y - anfang_y);
    			double real_x = anfang_x + (double)x / einheit_x;
    			double real_y = anfang_y + (double)(pixel_maxy - y) / einheit_y;
   
    			Beschriftung b = (Beschriftung)beschriftungen.get((beschriftungv-1));
    			b.setzeX(real_x);
    			b.setzeY(real_y);
    			beschriftungen.set((beschriftungv-1), b);
    			aktualisiere();
    		}
    	}
    	
    }
}