package grada;

import java.awt.Rectangle;
import java.util.ListResourceBundle;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JWindow;

import sprachen.Sprachen;


/** Zeigt StartBildschirm.
 * Ein typischer "SplashScreen" oder Startbildschirm, auf dem ganz kurz ein 
 * paar Copyright hinweise und ein tolles Bild stehen. Wenn die Anwendung 
 * geladen ist, wird dieser StartBildschirm wieder gelscht.
 * @author Thilo Beckmann
 * @version 06.07.05
 */
public class StartBildschirm{
	private static Sprachen	sprachen = Sprachen.holeSprache();
	private static ListResourceBundle sp = sprachen.holeSprachBundle();
	private JFrame f;
	private JWindow StartBildschirmFenster;
	private JLabel l;
	/** Konstruktor.
	 * erstellt ein Fenster als Startbildschirm, der nach kurzer Zeit wieder 
	 * ausgeblendet wird, wenn die Anwendung geladen ist.
	 * 
	 * @param f	Elternfenster(fr die Abhngigkeit)
	 */
	public StartBildschirm(JFrame f){
		this.f = f;
		l = new JLabel(new ImageIcon(sp.getString("StartBildschirm_Bild")));
		StartBildschirmFenster = new JWindow();
		StartBildschirmFenster.getContentPane().add(l);
		StartBildschirmFenster.pack();
		Rectangle screenRect = f.getGraphicsConfiguration().getBounds();
		StartBildschirmFenster.setLocation(
		screenRect.x + screenRect.width/2 
		- StartBildschirmFenster.getSize().width/2,
		screenRect.y + screenRect.height/2 
		- StartBildschirmFenster.getSize().height/2);	
		zeigeStartBildschirm();
	}
	/** zeigt den Bildschirm an
	 */
	public void zeigeStartBildschirm() {
		StartBildschirmFenster.setVisible(true);
	}
	/** entfernt / blendet ihn wieder aus
	 */
	public void entferneStartBildschirm() {
		StartBildschirmFenster.setVisible(false);
		StartBildschirmFenster.dispose();
		StartBildschirmFenster = null;
		l = null;
	}
}
