package grada.event;

import grada.geometriefiguren.Funktion;

/** FunktionsEvent.
 * Diese Klasse macht das gleiche bzw. etwas hnliches wie z.B. die Klasse 
 * ActionEvent. Sie wird vom FunktionsPanel erzeugt, wenn etwas an der 
 * Funktion gendert wird. 
 * @author Thilo Beckmann
 * @version 03.07.05
 *
 */ 
public class FunktionsEvent {
	private Funktion	funktion;
	private Funktion	alteFunktion;
	/** FunktionsEvent.
	 * Dieses Ereignis wird erstellt, wenn z.B. der Funktionsterm oder die 
	 * Farbe verndert wird. 
	 * @param funktionsCommand	Commando, was mit der Funktion geschehen soll
	 * @param funktion			Funktion, um die es geht
	 * @param altefunktion		alte Funktion, die gendert/gelscht wird
	 */
	public FunktionsEvent(Funktion funktion, Funktion alteFunktion){
		this.funktion			= funktion;
		this.alteFunktion		= alteFunktion;
	}
	/** Gibt die vernderte Funktion zurck.
	 * hier kann man die vernderte Funktion abrufen, um die es gerade geht.
	 * @return	vernderte Funktion
	 */
	public Funktion holeFunktion(){
		return funktion;
	}
	/** Gibt die alte Funktion zurck.
	 * hier kann man die alte Funktion abrufen, wie sie vor der Vernderung war
	 * @return	alte Funktion
	 */
	public Funktion holeAlteFunktion(){
		return alteFunktion;
	}
	/** Setzt die Funktion.
	 * Hiermit kann die Funktion im nachhinein verndert werden.
	 * @param funktion	neue Funktion
	 */
	public void setzeFunktion(Funktion funktion){
		this.funktion = funktion;
	}
	/** Setzt die alte Funktion.
	 * Hiermit kann die alte Funktion im nachhinein verndert werden.
	 * @param funktion	alte Funktion
	 */
	public void setzeAlteFunktion(Funktion alteFunktion){
		this.alteFunktion = alteFunktion;
	}
}
