package grada.geometriefiguren;

import java.awt.Color;
import java.io.Serializable;
/**
 * @author Thilo Beckmann
 * @version 07.07.05
 * Diese Klasse wird fr die Erstellung einer Beschriftung benutzt.
 * Alle Daten fr diese Beschriftung, werden in der Klasse gesetzt.  
 */
public class Beschriftung implements Serializable {
	private String		beschriftung;
	private Color		farbe;
	private double x	= 0.0;
	private double y	= 0.0;
	
	/** erstellt eine Instanz des Typs Beschriftung.
	 * 
	 * @param beschriftung	Text der Beschriftung
	 * @param farbe			Farbe der Beschriftung
	 * @param x				x-Position der Beschriftung
	 * @param y				y-Position der Beschriftung
	 */
	public Beschriftung (String beschriftung, Color farbe, double x, double y){
		this.beschriftung = beschriftung;
		this.farbe = farbe;
		this.x = x;
		this.y = y;
	}
	
	/** gibt die Beschriftung zurck.
	 * @return Beschriftung
	 */
	public String holeBeschriftung() {
		return beschriftung;
	}
	/** setzt eine Beschriftung.
	 * @param beschriftung 	Die neue Beschriftung
	 */
	public void setzeBeschriftung(String beschriftung) {
		this.beschriftung = beschriftung;
	}
	/** gibt die Farbe zurck.
	 * @return Farbe
	 */
	public Color holeFarbe() {
		return farbe;
	}
	/** setzt eine Farbe.
	 * @param farbe		die neue Farbe
	 */
	public void setzeFarbe(Color farbe) {
		this.farbe = farbe;
	}
	/** gibt die x-Position zurck.
	 * @return x-position
	 */
	public double holeX() {
		return x;
	}
	/** setzt die x-Position.
	 * @param x		die neue x-Position
	 */
	public void setzeX(double x) {
		this.x = x;
	}
	/** gibt die y-Position zurck.
	 * @return y-Position
	 */
	public double holeY() {
		return y;
	}
	/** setzt die y-Position.
	 * @param y 	die neue y-Position
	 */
	public void setzeY(double y) {
		this.y = y;
	}
}
