package grada.geometriefiguren;
import java.awt.Color;
import java.io.Serializable;
import java.util.ArrayList;

/**
 * Funktion.
 * Diese Klasse stellt eine Funktion dar, in ihr sind alle Informationen fr 
 * die Bearbeitung enthalten. Der Funktionsterm, der eingegeben wurde, die 
 * Farbe, und die Information, ob gerade zustzliche Informationen eingeblendet 
 * werden.
 * 
 * @author		(C) Thilo Beckmann
 * @version		07.07.05
 */
public class Funktion implements Serializable{
	private String	funktionsterm;
	private boolean	anzeigeAnMaus;
	private boolean sichtbar;
	private Color	farbe;
	private ArrayList ableitungen;


	/** Konstruktor fr eine Instanz des Typs Funktion.
	* @param	funktionsterm der Funktionsterm gestellt die Funktion dar
	* @param	anzeigeAnMaus wenn true, dann wird an der Maus der y-Wert 
	*			der Funktion angezeigt
	* @param	sichtbar bei true sichbar, bei false unsichtbar
	* @param	farbe weit der Funktion eine bestimmte Farbe zu
	* @param	ableitungen	ArrayList mit allen anzuzeigenen Graden der
	* 			Ableitungen
	*/
	public Funktion(String funktionsterm, boolean anzeigeAnMaus, 
			boolean sichtbar, Color farbe, ArrayList ableitungen){
		this.funktionsterm	= funktionsterm;
		this.anzeigeAnMaus	= anzeigeAnMaus;
		this.sichtbar		= sichtbar;
		this.farbe			= farbe;
		this.ableitungen	= ableitungen;
	}


	/** ndert den Funktionsterm der Funktion.
	* @param	funktinosterm neuer Funktionsterm
	*/
	public void setzeFunktionsTerm(String funktionsterm){
		this.funktionsterm	= funktionsterm;
	}
	/** ndert die Einstellung ob Informationen an der Maus angezeigt werden.
	* @param	anzeigeAnMaus wenn true wird die Information angezeigt,
	*			wenn false dann nicht
	*/
	public void setzeAnzeigeAnMaus(boolean anzeigeAnMaus){
		this.anzeigeAnMaus	= anzeigeAnMaus;
	}
	/** ndert die Einstellung ob Informationen an der Maus angezeigt werden.
	* @param	anzeigeAnMaus wenn true wird die Information angezeigt,
	*			wenn false dann nicht
	*/
	public void setzeSichtbarkeit(boolean sichtbar){
		this.sichtbar	= sichtbar;
	}
	/** ndert die zugewiesene Farbe der Funktion.
	* @param	farbe gibt die neue Farbe an
	*/
	public void setzeFarbe(Color farbe){
		this.farbe			= farbe;
	}
	/** ndert die Einstellung welche Ableitungen angezeigt werden sollen.
	 * 
	 * @param ArrayList mit allen Nummern, welche Ableitung angezeigt wird
	 */
	public void setzeAbleitungen (ArrayList ableitungen){
		this.ableitungen	= ableitungen;
	}
	
	/** gibt den Funktinnterm der Funktion zurck.
	* @return	gibt den Funktionsterm der Funktion zurck
	*/
	public String holeFunktionsTerm (){
		return funktionsterm;
	}
	/** gibt die aktuelle Einstellung der besonderen Anzeige zurck.
	* @return	gibt Einstellung zurck
	*/
	public boolean wirdAnMausAngezeigt(){
		return anzeigeAnMaus;
	}
	/** gibt die aktuelle Einstellung der Sichtbarkeit zurck.
	* @return	gibt Einstellung zurck
	*/
	public boolean istSichtbar(){
		return sichtbar;
	}
	/** gibt die eingestellte Farbe der Funktion zurck.
	* @return	liefert Farbe zurck
	*/
	public Color holeFarbe(){
		return farbe;
	}
	/** gibt die eingestellten Ableitungen zurck 
	 * 
	 * @return	ArrayList mit allen Nummern, der Ableitungen.
	 */
	public ArrayList holeAbleitungen(){
		return ableitungen;
	}
}