package grada.geometriefiguren;
import java.awt.*;
/**
 * Diese Klasse stellt einen Punkt (besser: einen groen Punkt) dar.
 * Man kann ihm eine Position (x/y), eine Farbe und einen Radius geben.
 * Der Radius ist z. B. beim Spiel PunkteTreffen wichtig.
 * @author Thilo Beckmann
 * @version 06.07.05
 */
public class Punkt{
	private int 	id;
	private double	x;
	private double	y;
	private double	radius;
	private Color	farbe;

	/** Konstruktor fr eine Instanz des Typs Punkt.
	* @param	id gibt dem Punkt eine Identifikationsnummer
	* @param	x gibt dem Punkt eine x-Koordinate
	* @param	y gibt dem Punkt eine y-Koordinate
	* @param	radius gibt dem Punkt eine Ausdehnung (z.B. zum 
	*			besseren Erkennen)
	* @param	farbe gibt dem Punkt eine Farbe
	*/
	public Punkt(int id, double x, double y, double radius, Color farbe){
		this.id		= id;
		this.x		= x;
		this.y		= y;
		this.radius	= radius;
		this.farbe	= farbe;
	}
	/** setzt die x Koordinate des Punktes neu.
	* @param	x neue x-Koordinate
	*/
	public void setzeX(double x){
		this.x		= x;
	}
	/** setzt die y Koordinate des Punktes neu.
	* @param	y neue y-Koordinate
	*/
	public void setzeY(double y){
		this.y		= y;
	}
	/** setzt die x und y Koordinate des Punktes neu.
	* @param	x neue x-Koordinate
	* @param	y neue y-Koordinate
	*/
	public void setzeXY(double x, double y){
		this.x		= x;
		this.y		= y;
	}
	/** setzt Radius des Punktes neu.
	* @param	radius neuer Radius
	*/
	public void setzeRadius(double radius){
		this.radius	= radius;
	}
	/** setzt die Farbe des Punktes neu.
	* @param	farbe neue Farbe des Punktes
	*/
	public void setzeFarbe(Color farbe){
		this.farbe	= farbe;
	}
	/** holt die x-Koordinate des Punktes
	* @return	gibt die x-Koordinate des Punktes zurck
	*/
	public double holeX(){
		return x;
	}
	/** holt die y-Koordinate des Punktes
	* @return	gibt die y-Koordinate des Punktes zurck
	*/
	public double holeY(){
		return y;
	}
	/** holt den Radius des Punktes
	* @return	gibt den Radius des Punktes zurck
	*/
	public double holeRadius(){
		return radius;
	}
	/** holt die Farbe des Punktes
	* @return	gibt die Farbe des Punktes zurck
	*/
	public Color holeFarbe(){
		return farbe;
	}
	/** holt die Identifikationsnummer des Punktes
	* @return	gibt die Identifikationsnummerx des Punktes zurck
	*/
	public int holeId(){
		return id;
	}
}
