package grada.geometriefiguren;
/**
 * Liefert einen Punkt, der nur integer-Koordinaten hat.
 * Schnittstelle zwischen dem Parser und dem Schaubild. Die
 * berechneten Wertepaare des Parsers werden als ArrayList
 * mit Objecten des Typs Punkt2d an das Schaubild bergeben. 
 * @author Christian Bormann
 * @version v.1
 */
public class Punkt2d{
	private double	x;
	private double	y;
	
	/** Konstruktor fr eine Instanz des Typs Punkt.
	* @param	x gibt dem Punkt eine x-Koordinate
	* @param	y gibt dem Punkt eine y-Koordinate
	*/
	public Punkt2d(double x, double y){
		this.x		= x;
		this.y		= y;
	}
	/** setzt die x Koordinate des Punktes neu.
	* @param	x neue x-Koordinate
	*/
	public void setzeX(double x){
		this.x		= x;
	}
	/** setzt die y Koordinate des Punktes neu.
	* @param	y neue y-Koordinate
	*/
	public void setzeY(double y){
		this.y		= y;
	}
	/** holt die x-Koordinate des Punktes
	* @return	gibt die x-Koordinate des Punktes zurck
	*/
	public double holeX(){
		return x;
	}
	/** holt die y-Koordinate des Punktes
	* @return	gibt die y-Koordinate des Punktes zurck
	*/
	public double holeY(){
		return y;
	}
}
