package grada.interfaces;

import grada.event.FunktionsEvent;

/**
 * Dieses Interface sorgt dafr, dass die nderungen von Funktionen auch 
 * in der Benutzeroberflche ankommen, und nicht irgendwo in einer tiefen 
 * Struktur stecken bleiben.
 * @author Thilo Beckmann
 * @version 07.07.05
 */
public interface InterfaceFunktionsAenderung {
	/** wird aufgerufen, wenn eine Funktion verndert wurde.
	 * z. B.: Farbe, Funktionsterm, AnzeigeStatus, etc...
	 * @param e	FunkionsEvent
	 */
	public void funktionWurdeVeraendert (FunktionsEvent e);
	/** wird aufgerufen, wenn eine Funktion gelscht werden soll.
	 * @param e	FunktionsEvent
	 */
	public void funktionsWurdeGeloescht(FunktionsEvent e);
}
