package grada.interfaces;

/**
 * Dieses Interface sorgt dafr, dass alle Bedienoberflchen, die den Parser 
 * in irgendeiner Form benutzen, die korrigierte Form vom Parser bekommen 
 * knnen bzw. die Werte schnell an den Parser bergeben werden knnen.
 * @autor	Thilo Beckmann
 * @version	29.06.05 
 */
public interface InterfaceParserEingabe {
	/**
	 * Diese Methode bietet dem Parser die Mglichkeit die eingegebenen Terme 
	 * korrigiert zurckzugeben.
	 * @param term	gibt den korrigierten Term als String zurck
	 */
	public void setzeTermEingabe(String term);
	
	/**
	 * Diese Methode ist fr den Parser wichtig, um die Werte des Terms schnell 
	 * mit neuen Parameterwerten zu berechnen. 
	 * @return 	Array aus double der Lnge 26 mit allen Parameterwerten 
	 * 			zurck (A-Z)
	 */
	public double[] holeTermParameter();
	
	/**
	 * Diese Methode bietet dem Parser die Mglichkeit Informationen zum 
	 * eingegebenen Term an die Bedienoberflche zu bermitteln. 
	 * @param info	Informationen zum geparsten Term 
	 */
	public void setzeTermInformation(String info);
	
	/** Diese Methode sagt der implementierenden Klasse, dass eine Funktion 
	 * mit dem fehlerhaftenTerm nicht korrekt ist, im korrigierten Term 
	 * befindet sich die vom Benutzer korrigierte Version
	 * @param fehlerhafterTerm	fehlerhafter Funktionsterm
	 * @param korrigierterTerm	korrigierter Funktionsterm
	 */
	public void funktionFehlerhaft(String fehlerhafterTerm, 
			String korrigierterTerm);
}
