package grada.steuereinheit;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import grada.interfaces.*;
import grada.event.*;
import sprachen.Sprachen;

import java.util.*;
import java.awt.event.*;
/**
 * Hier wird die Benutzereingabe fr Funktionen bereitgestellt.
 * Falle eine Funktion hinzugefgt werden soll, wird das entsprechende
 * Event in der FunktionenAnzeige aufgerufen.
 * @author T-Low
 * @version 08.07.05
 */
public class FunktionsEingabeFeld extends JPanel implements ActionListener{
	private Sprachen	sprachen = Sprachen.holeSprache();
	private ListResourceBundle	sp = sprachen.holeSprachBundle();

	private InterfaceFunktionsEingabe listener;
	private final JLabel		eingabeTitel	= new JLabel(sp.getString("FuAnz_Funktionseingabe:"));
	private JButton		eingabeparsen;
	private JTextField	eingabe;
	private static final Insets abstand	= new Insets (0,0,0,0);
	
	private static final Color titelBackground	= new Color (100,139,203);
	private static final Color titelForeground	= new Color (255,255,255);

	/** Setzt Attribute eines Labels.
	 * Diese Methode setzt die Attribute eines Labels, um dieses als 
	 * berschrift zur Gliederung der Oberflche hervorzuheben.  
	 * @param obj	JLabel, das als berschrift benutzt werden soll.
	 */
	private void setzeTitelEigenschaften (JLabel obj){
		obj.setBackground(titelBackground);
		obj.setForeground(titelForeground);
		obj.setOpaque(true);
		obj.setHorizontalAlignment(SwingConstants.CENTER);
		obj.setVisible(true);
	}	
	
	/** Erstellt ein Eingabefeld.
	 * Erstellt ein Eingabefeld, in das die Funktionsterme eingetippt 
	 * werden knnen. Es wird die angegebene Funktion ins Feld geschrieben.
	 * @param funktionsterm		Funktionsterm, der ins Feld geschrieben wird
	 */
	public FunktionsEingabeFeld(String funktionsterm, InterfaceFunktionsEingabe listener){
		this.listener = listener;
		setLayout(new GridBagLayout());
		setzeTitelEigenschaften(eingabeTitel);
		JButton		eingabeparsen = new JButton();
		eingabe			= new JTextField(funktionsterm);
		eingabe			.setActionCommand("eingabeparsen");
		eingabe			.addActionListener(this);
		eingabeparsen	= new JButton(sp.getString("FuAnz_F(x) zeichnen"));
		eingabeparsen	.setActionCommand("eingabeparsen");
		eingabeparsen	.addActionListener(this);
		
		GridBagHinzufueger.add(this,eingabeTitel,	0,0,6,1,1,0,GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,abstand);
		GridBagHinzufueger.add(this,eingabe,		0,1,6,1,1,0,GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,abstand);
		GridBagHinzufueger.add(this,eingabeparsen,	0,2,6,1,0,0,GridBagConstraints.NONE,GridBagConstraints.WEST,abstand);
	}
	/** setzt den EingabeText
	 * 
	 * @param text	Text der in der Eingabe stehen soll
	 */
	public void setzeEingabeText(String text){
		eingabe.setText(text);
	}
	/** gibt Eingabetext zurck.
	 * @return	gibt Text aus der Eingabe zurck.
	 */
	public String holeEingabeText(){
		return eingabe.getText();
	}
	public void actionPerformed(ActionEvent e){
		if (!(holeEingabeText().trim()).equals("")){
			listener.funktionsTermIstEingegebenWorden(new FunktionsEingabeEvent(holeEingabeText()));
		}
	}
	
}
