package grada.steuereinheit;
// diese Idee stammte aus unserem alten Informatik Buch
import java.awt.*;
public class GridBagHinzufueger{
	static GridBagConstraints cons = new GridBagConstraints();
	/**
	 * Fgt ein Objekt zu einem Layout hinzu.
	 * Mit dieser Methode kann man sehr einfach, verschiedene Objecte zu einem Layout hinzufgen, da
	 * nicht alle Eigenschaften einzeln nder muss, sondern alle in einer Zeile unterbringen kann. 
	 * 
	 * @param contain	Container in das das Objekt eingefgt werden soll (z. B. ein Panel)
	 * @param comp		Object, welches eingefgt werden soll
	 * @param x			In diese Spalte des Layouts wird das Object eingefgt
	 * @param y			In diese Zeile des Layouts wird das Object eingefgt
	 * @param width		Soviele Spalten nimmt das Object in Anspruch (/werden zusammengefasst); 
	 * 					hnlich wie colspan in html 
	 * @param height	Soviele Zeilen nimmt das Object in Anspruch (/werden zusammengefasst);
	 * 					hnlich wie rowspan in html 
	 * @param weightx	Platzgewichtung in der Spalte
	 * @param weighty	Platzgewichtung in der Zeile
	 * @param fill		Mit den GridBagConstraints wird angegeben, wie das Object die Zelle ausfllt
	 * @param anchor	Mit den GridBagConstraints wird angegeben, wie das Object in der Zelle ausgerichtet wird
	 * @param insets	Abstand vom Object zum Rand
	 */
	public static void add(Container cont, Component comp, int x, int y,
		int weite, int hoehe, int gewichtungx, int gewichtungy, int fill, int anchor, Insets insets){
		cons.gridx	= x;
		cons.gridy	= y;
		cons.gridwidth	= weite;
		cons.gridheight	= hoehe;
		cons.weightx	= gewichtungx;
		cons.weighty	= gewichtungy;
		cons.fill		= fill;
		cons.anchor		= anchor;
		cons.insets		= insets;
		cont.add(comp, cons);
	}
	/**
	 * Entfernt aus einem Layout ein Element.
	 * 
	 * @param panel		Container aus dem ein Object gelscht werden soll
	 * @param comp		Object das aus dem Container gelscht werden soll
	 */
	public static void remove(Container cont, Component comp){
		if (comp!=null){
			comp.setVisible(false);
			cont.remove(comp);
			comp = null;
		}
	}
}
