package grada.steuereinheit;

import grada.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;

import sprachen.Sprachen;

import java.awt.event.*;
import java.util.ListResourceBundle;

/**
 * @author Felix
 * @version 1.5 (vom 05.07.2005)
 */
/**Diese Klasse dient in den Spielen der Erfassung der Anzahl und der Namen der 
 * Spieler. Zu diesem Zweck wird im folgenden ein Dialog erstellt.
 */
public class SpieleDialog implements ActionListener{
	private Sprachen	sprachen = Sprachen.holeSprache();
	private ListResourceBundle	sp = sprachen.holeSprachBundle();
	private JDialog dialog;
	
	/*Hier handelt es sich um Variablen, die die Maximale bzw die wirkliche 
	 * Spieleranzahl angeben.*/
	private int maxspieler;
	private int anzahlspieler;
	private int alteanzahl;
	private Spieler altespieler[];
	private Spieler spieler[];
	
	/*Die folgenden Variablen dienen der Erstellung der Oberflche.*/
	private Insets insets;
	private JFormattedTextField anzahl;
	private JTextField namen[];
	private JButton abbrechen;
	private JButton ok;
	public JLabel beschreibung[];
	public final int ANZAHLBESCHREIBUNGEN = 2;
	
	/*Diese Variable gibt das Spiel an, aus dem der Dialog aufgerufen wird.*/
	private PunkteTreffen punktetreffen;
	
	/*Diese Variablen dienen der Vereinfachung des Quelltextes.*/
	private final int HORIZONTAL = GridBagConstraints.HORIZONTAL;
	private final int CENTER = GridBagConstraints.CENTER;
	
	/**Dies ist der Construktor der Klasse Dialog.
	 * Hier werden die ntigen Variablen initialisiert und die Objekte definiert.
	 */
	public SpieleDialog (Spieler spieler[], PunkteTreffen quelle, int max, 
			int alteanzahl){
		JPanel spiel = quelle;
		
		punktetreffen = (PunkteTreffen) quelle;
		maxspieler = max;
		altespieler = spieler;
		
		insets = new Insets(1,1,1,1);
		
		dialog = new JDialog();
		dialog.addWindowListener(new WindowAdapter(){
									public void windowClosing(WindowEvent e){
											punktetreffen.dialogIstAbgebrochen();
										}
									});
		dialog.setLayout(new GridBagLayout());
		
		beschreibung = new JLabel [ANZAHLBESCHREIBUNGEN];
		for (int i=0;i<ANZAHLBESCHREIBUNGEN-1;i++){
			beschreibung[i] = new JLabel("");
			beschreibung[i].setBackground(new Color(100,139,203));
			beschreibung[i].setOpaque(true);
			beschreibung[i].setForeground(new Color(255,255,255));
			beschreibung[i].setHorizontalAlignment(SwingConstants.CENTER);
		}
		beschreibung[0].setText(sp.getString("SpDial_Anzahl und Namen der Spieler:"));
		/*Diese Label soll "normal aussehen"*/
		beschreibung[1] = new JLabel(sp.getString("SpDial_Anzahl Spieler: (max. 5)"));
		
		/*Hier wird ein Text Feld gesetzt, dass nur Zahlen erlaubt.
		 * Es sind nur die Zahlen 1,2,3,4 und 5 zugelassen.
		 * In deisem Fall auch nur eine einzige von ihnen.
		 */
		try{
			MaskFormatter zahlentextfeld = new MaskFormatter("#");
			zahlentextfeld.setValidCharacters("12345");
			anzahl = new JFormattedTextField(zahlentextfeld);
		}
		catch(Exception e){}
		anzahl.setText("1");
		anzahl.addKeyListener(new KeyAdapter(){
								public void keyReleased(KeyEvent e){
									TastenEvent();
								}});
		anzahl.addActionListener(this);
		anzahl.setActionCommand("0");
		
		anzahl.addMouseListener(new MouseEvents());
		
		/*Jetzt werden die Textfelder erstellt, 
		 * in die spter die Spielernamen eingegeben werden knnen.
		 */
		namen = new JTextField[maxspieler];
		for(int i=0; i<maxspieler; i++){
			namen[i] = new JTextField(sp.getString("SpDial_Spieler ")+(i+1));
			namen[i].setEnabled(false);
			
			namen[i].addActionListener(this);
			namen[i].setActionCommand(""+(i+1));
			namen[i].addMouseListener(new MouseEvents());
			
			GridBagHinzufueger.add(dialog,namen[i],1,3+i,2,1,1,1,HORIZONTAL,CENTER,insets);
		}
			namen[0].setEnabled(true);
		for(int i=0; i<alteanzahl; i++){
			namen[i].setText(altespieler[i].getName());
		}

		
		/*Als letztes werden die Buttons initialisiert.
		 */
		abbrechen = new JButton(sp.getString("SpDial_Abbrechen"));
		abbrechen.addActionListener(this);
		
		ok = new JButton(sp.getString("SpDial_OK"));
		ok.addActionListener(this);
		
		/*Hier wird die Oberflaeche schlielich auch sichtbar erstellt.
		 */
		GridBagHinzufueger.add(dialog,beschreibung[0],1,1,4,1,1,1,HORIZONTAL,CENTER,insets);
		GridBagHinzufueger.add(dialog,beschreibung[1],1,2,1,1,1,1,HORIZONTAL,CENTER,insets);
		GridBagHinzufueger.add(dialog,anzahl,2,2,1,1,1,1,HORIZONTAL,CENTER,insets);
		GridBagHinzufueger.add(dialog,abbrechen,1,maxspieler+4,1,1,1,0,HORIZONTAL,CENTER,insets);
		GridBagHinzufueger.add(dialog,ok,2,maxspieler+4,1,1,1,0,HORIZONTAL,CENTER,insets);
		
		/*Die letzten Einstellungen beziehen sich auf den Dialog als ganzen.
		 * Er wird sichtbar gemacht, in den Vordergrund und in die Mitte gesetzt.
		 */
		dialog.pack();
		dialog.setVisible(true);
		dialog.setLocationRelativeTo(null);
		dialog.setAlwaysOnTop(true);
		dialog.requestFocusInWindow();
		dialog.setResizable(false);
		
		/*Hier wird der Fokus auf das Feld Anzahl gesetzt und alles markiert.
		 */
		anzahl.requestFocus(false);
		anzahl.selectAll();
	}
	
	
	/**Hier wird die Anzahl der Spieler zurckgegeben.
	 */
	public int getSpielerAnzahl(){
		try{
			return new Integer(anzahl.getText()).intValue();
		}
		catch(Exception e){
			/*Falls es einen Fehler geben sollte, wird die vorherige 
			* spieleranzahl zurckgegeben.*/
			return anzahlspieler;
		}
	}
	
	/**Diese Methode gibt ein String Array zurck, das alle Spielernamen 
	 * enthlt.
	 */
	public Spieler[] getSpieler(){
		Spieler[] spieler = new Spieler[maxspieler];
		for(int i=0;i!=anzahlspieler; i++){
			if(namen[i].getText().equals("")){
				spieler[i].setName(sp.getString("SpDial_Spieler ")+(i+1));
			}
			else{
				spieler[i].setName(namen[i].getText());
			}
		}
		return spieler;
	}
	
	/**Diese Methode wird ausgefuehrt, wenn im JFormattedTextField eine Taste 
	 * gedrueckt wird. Es wird die noetige Anzahl an JTextFields zum benutzen 
	 * bereit gemacht. Diese Anzhal entspricht genau der Anzahl der Spieler, 
	 * die ausgewhlt wurde.
	 */
	private void TastenEvent() {
		if(getSpielerAnzahl()>0  && getSpielerAnzahl()<6){
			anzahlspieler = getSpielerAnzahl();
			//Diese Schleife deaktiviert alle TextFelder. Danach werden einige 
			//wieder aktiviert.
			for(int i=0;i<maxspieler; i++){
				namen[i].setEnabled(false);
			}
			
			for(int i=0;i<anzahlspieler; i++){
				namen[i].setEnabled(true);
			}
		}
		anzahl.selectAll();
	}
	
	
	
	public void actionPerformed(ActionEvent e) {
		String s = e.getActionCommand();
		Object o = e.getSource();
		if(s.equals(sp.getString("SpDial_Abbrechen"))){
			dialog.setVisible(false);
			punktetreffen.dialogIstAbgebrochen();
		}
		else if(s.equals(sp.getString("SpDial_OK"))){
			dialog.setVisible(false);
			anzahlspieler = getSpielerAnzahl();
			spieler = new Spieler[anzahlspieler];
			for(int i=0;i<anzahlspieler;i++){
				spieler[i]= new Spieler(namen[i].getText());
			}
			punktetreffen.dialogIstAusgefuehrt(anzahlspieler,spieler);
		}
		/*Immer wenn man ENTER drckt springt der Focus ein TextFeld weiter.
		 */
		else if(s.equals("0")){
			namen[0].requestFocus();
			namen[0].selectAll();
		}
		else if(s.equals("1") || s.equals("2") || s.equals("3") || s.equals("4") || s.equals("5")){
			int i = (new Integer(s)).intValue();
			if(i != anzahlspieler){
				namen[i].requestFocus();
				namen[i].selectAll();
			}
		}
	}
	
}

/**Diese Klasse wird ausgefhrt, sobalt man mit der Maus auf eines der
 * TextFelder klickt. Daraufhinn wird alles, was in diesem TextFeld 
 * steht markiert.
 */
class MouseEvents extends MouseAdapter{
	public void mouseClicked(MouseEvent e){
		Object o = e.getSource();
		if(o instanceof JTextField){
			((JTextField)o).selectAll();
		}
	}
}
