package grada.steuereinheit;

import java.io.Serializable;

/**
 * Diese Klasse speichert alle noetigen daten fuer jeweils einen Spieler.
 * @author Felix
 * @version 1.0 (vom 05.07.2005)
 */
public class Spieler implements Comparable, Serializable{
	String spielername;
	Integer anzahlpunkte;
	int anzahltreffer;
	int anzahlversuche;
	
	/**Mit Hilfe des Construktors werden die noetigen Daten gespeichert.*/
	public Spieler(String name){
		spielername = name;
		anzahlpunkte = new Integer(0);
		anzahltreffer = 0;
		anzahlversuche = 0;
	}
	
	/**Diese Methoden setzen den Namen des Spielers bzw geben ihn zurueck..*/
	public String getName(){
		return spielername;
	}
	public void setName(String name){
		spielername = name;
	}
	
	/**Diese Methoden setzten bzw geben die Punkte des Spielers.*/
	public Integer getPunkte(){
		return anzahlpunkte;
	}
	public void setPunkte(int punkte){
		anzahlpunkte = new Integer(punkte);
	}
	
	/**Diese Methoden behandeln die Anzahl der Versuche, die ein spieler bentigt
	 *hat, um alle ballons zu treffen*/
	public int getAnzahlVersuche(){
		return anzahlversuche;
	}
	public void setAnzahlVersuche(int anzahl){
		anzahlversuche = anzahl;
	}
	
	/*Diese Methoden behandeln die Anzahl der Treffer eines Spielers.*/
	public int getAnzahlTreffer(){
		return anzahltreffer;
	}
	public void setAnzahlTreffer(int anzahl){
		anzahltreffer = anzahl;
	}
	
	/**Diese Methode macht es moeglich, dass eine Liste von Spielern sortiert
	 * werden kann. Zu diesem Zweck wird ihre Punktzahl verglichen.
	 */
	public int compareTo(Object o) {
		Spieler spieler = (Spieler) o;
		return spieler.getPunkte().compareTo(anzahlpunkte);
	}
}
