/**
 * Created on 11.09.2005
 *	Diese Klasse dien dem Parser als Fehlermeldung. Immer wenn dor ein Fehlerauftritt
 *	wird dieser Frame aufgerufen. Er zeigt dem Benutzter, wo der Fehler ist und lsst
 *	ihn diesen beheben.
 */
package parser;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import grada.interfaces.InterfaceParserEingabe;
import grada.steuereinheit.GridBagHinzufueger;


public class Fehlermeldung implements ActionListener, WindowListener{
   private JDialog fenster;
   
   private JMenuBar menubar;
   private JMenu file;
   private JMenuItem Item[];
   
   private Container container;
   
   private JTextField eingabe;
   private JTextArea ausgabe;
   private JScrollPane scrollpane;
   
   private JButton aendern;
   private JButton details;
   
   private final int CENTER = GridBagConstraints.CENTER;
   
   private final int NONE = GridBagConstraints.NONE;
   private final int BOTH = GridBagConstraints.BOTH;
   private final int HORIZONTAL = GridBagConstraints.HORIZONTAL;
   
   private Insets insets; 
   private String stack, fehler, ort;
   private InterfaceParserEingabe bedienfeld;
   
   public Fehlermeldung(){
    	init();
   }
   
   /**
    * Diese Methode initialsiert die eigentliche Fehlermeldung mit ihren Buttons u..
    * Der Frame bleibt allerdings noch unsichtbar, da er noch nicht bentigt wird.
    */
   private void init(){
		fenster  = new JDialog();
		
		container = new Container();
		container = fenster.getContentPane();
		container.setLayout(new GridBagLayout());
		insets = new Insets(2,2,2,2);
		
		menuinit();
		einausgabeinit();
		buttonsinit();
		
		fenster.pack();
		fenster.setResizable(false);
		fenster.setLocationRelativeTo(null);
		fenster.setAlwaysOnTop(true);
		fenster.requestFocus();
		fenster.setVisible(false);
   }
   
   /**
    * Hier wird das Menue,das im Frame zu finden ist, erstellt.
    */
   private void menuinit(){
    	menubar  = new JMenuBar();
		file     = new JMenu("File");
		Item     = new JMenuItem [2];
			Item[0] = new JMenuItem("ndern");
			Item[1] = new JMenuItem("Details >>");
    	
		fenster.setJMenuBar(menubar);
			menubar.add(file);
				file.add(Item[0]);
				file.add(Item[1]);
		
		Item[0].addActionListener(this);
		Item[1].addActionListener(this);
    }
    
   /**
    * Hier wird die Eingabe und Ausgabe bereitgestellt.
    */
    private void einausgabeinit(){
    	ausgabe = new JTextArea(10,35);
    	ausgabe.setLineWrap(true);
		scrollpane = new JScrollPane(ausgabe);
		eingabe = new JTextField();
		
		GridBagHinzufueger.add(container,scrollpane,1,1,4,10,1,1,BOTH,CENTER,insets);
		GridBagHinzufueger.add(container,eingabe,1,11,4,1,1,1,HORIZONTAL,CENTER,insets);
		
		ausgabe.setWrapStyleWord(true);
		ausgabe.setEditable(false);
		
		eingabe.addActionListener(this);
    }
    
    /**
     * In dieser Methode werden schlielich die Buttons initialisiert.
     */
    private void buttonsinit(){
    	aendern  = new JButton(Item[0].getText());
    	details  = new JButton("Details");
    	details.setActionCommand(Item[1].getText());
    	
    	GridBagHinzufueger.add(container,aendern,2,12,1,1,1,1,NONE,CENTER,insets);
    	GridBagHinzufueger.add(container,details,4,12,1,1,1,1,NONE,CENTER,insets);
    	
    	aendern.addActionListener(this);
		details.addActionListener(this);
    }
   
    /**
     * Diese Methode ermglicht es spter dem Parser ein neues Fenster mit einer neuen
     * Fehlermeldung zu erzeugen. Ab hier ist der Frme zu sehen. 
     */
    public String neuerFehler(String fehler, String ort, String stack, InterfaceParserEingabe bedienfeld){
    	init();
    	fenster.setVisible(true);
    	
		this.stack = stack;
		this.ort = ort;
		this.fehler = fehler;
		this.bedienfeld = bedienfeld;
		
		ausgabe.setText(fehler+"\n"+ort);
		eingabe.setText(ort);
		
		
		
		return "";
	}
    
	public void actionPerformed(ActionEvent e){
		String s = e.getActionCommand();
		Object o = e.getSource();
		if(s.equals("Details >>")){
			ausgabe.append("\n"+"\n"+stack);
			
			Item[1].setActionCommand("Details <<");
			Item[1].setText("Details <<");
			details.setActionCommand(Item[1].getActionCommand());
		}
		else if(s.equals("Details <<")){
			ausgabe.setText(fehler+"\n"+ort);
			
			Item[1].setActionCommand("Details >>");
			Item[1].setText("Details >>");
			details.setActionCommand(Item[1].getActionCommand());
		}
		else if(s.equals("ndern")){
			aendern();
			
		}
		else if(o instanceof JTextField){
			aendern();
		}
	}
	
	/**
	 * Diese Methode behebt den Fehler auch im Hauptfenster.
	 */
	private void aendern(){
		bedienfeld.funktionFehlerhaft(ort,eingabe.getText());
		fenster.setVisible(false);
		Parser.aktualisierenErlaubt = true;
	}
	
	public void windowClosed(WindowEvent e) {
		bedienfeld.funktionFehlerhaft(ort,eingabe.getText());
		fenster.setVisible(false);
		Parser.aktualisierenErlaubt = true;
	}
	
	public void windowOpened(WindowEvent e) {}
	public void windowClosing(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowActivated(WindowEvent e) {}
	public void windowDeactivated(WindowEvent e) {}
}