package parser;

import parser.baeume.Baum;
import java.util.*;

/**Diese Klasse enthlt alle Teile einer Funktion: Den Funkionsbaum, die Parameter, die
 * in dieser Funktion auftauchen.
 * Diese Klasse macht nichts anderes, als Referenzen zu speichern und zurckzugeben.
 * @author Stephan Hagebck
 */
class Funktionenspeicher {
    /**Der Funktionsterm*/
    protected String Funktionsterm;
    /**Der oberste Ast des Funktionsbaumes*/
    protected Baum Funktionsbaum;
    /**Alle Parameter, die die Funktion enthlt*/
    protected ArrayList Parameter;
    /**Enthlt die Ableitungen der Funktion*/
    protected ArrayList Ableitungen;
    
    /**Instanziert einen Funktionenspeicher mit den folgenden Variablen:
     * @param f Der Funktionsterm
     * @param b Der Baum, der nach dem Parsen des Terms entsteht
     * @param parameter Eine Liste mit allen Parametern, die im Funktionsterm vorkommen (alphabetisch sortiert).
     */
    protected Funktionenspeicher(String f, Baum b, HashSet parameter)
    {
        Funktionsterm= f;
        Funktionsbaum= b;
        ArrayList liste= new ArrayList(parameter);
        Collections.sort(liste);
        Parameter=liste;
        Ableitungen =new ArrayList();
    }
}
