package parser;


/**Eine Exception zustndig fr die Benachrichtigung des Nutzers, wenn eine falsche Funktion eingegeben wurde.
 * @author Stephan Hagebck
 */
public class Lesefehler extends Exception {
	private String Term;
	private String hoehererTerm;
	
	/**Erzeugt eine neue Exception Lesefehler, die eine Nachricht ber die Ursache des Problems,
	 * sowie einen String mit dem Term, der den Fehler verursachte enthlt.
	 * <br>Der bergeordnete Term wird ber eine Methode angehngt, damit man den Fehler bei sehr kleinen Termen
	 * besser eingrenzen kann.
	 * @param Nachricht Der Fehlerhinweis
	 * @param Term Der fehlerhafte Term
	 */
	public Lesefehler(String Nachricht, String Term) {
		super(Nachricht+"\n Trat auf im Teil \""+Term+"\"");
		this.Term=Term;
	}
	
	
	/**Setzt den bergeordneten Funktionsterm zur besseren Eingrenzung des Problems bei kleinen Termen.
	 * 
	 * @param Term Der Term
	 */
	public void setzeFunktionsterm (String Term) {
	    hoehererTerm=Term;
	}
	
	
	/**Gibt den fehlerhaften Teil der Funktion als String zurck.
	 * @return Den Funktionsterm
	 */
	public String ort() {
		return Term;
	}
	
	
	/**Gibt den bergeordneten Term des Fehlerhaften Terms zurck.
	 * @return Der bergeordnete Term
	 */
	public String Funktionsterm() {
	    return hoehererTerm;
	}
}
