package parser.baeume;


/**Unterster Teil eines Baumes. Enthlt Werte wie 25 oder 25x.
 * @author Stephan Hagebck
 */
class Blatt extends Baum {
    /**Enthlt den Faktor, der angibt, wie oft der Parameter auftritt. (0,7x)*/
    protected double faktor;
    /**Name des Parameters im Funktionsterm*/
    protected char parameter;
    /**Enscheidet, wie sich der Baum z.B. beim Ableiten verhlt*/
    protected boolean xVorhanden;
    /**Wenn kein Parameter vorhanden ist*/
    protected boolean keinParameter;
    /**Berechnung der Werte fr einen Parameter im Gradma*/
    protected boolean gradMass;
    
    
    /**Instanziert ein neues Blatt des Baumes. Das Blatt ist das tiefste Element eines Baumes.
     * Hier werden die Parameter aufbewahrt, die mit Werten besetzt werden, sobald ein Funktionswert angefordert wird.
     * @param faktor Faktor, der angibt, wie oft der Parameter auftritt
     * @param parameter Name des Parameters im Funktionsterm
     */
    Blatt(double faktor, char parameter){
    	this.faktor=faktor;
    	this.parameter=parameter;
    	if (parameter=='x') xVorhanden=true;
    	if (parameter=='?') keinParameter=true;
    	else if (parameter!='x')BaumErzeuger.vorhandeneParameter.add(new Character(parameter));
    }
    
    
    /**Nicht untersttzt, aus diesem Grund berschrieben, um nichts zu machen.
     */
    void haengeAn(Baum baum){
        System.out.println("An Bltter gehren keine ste!"+this.toString());
    }
    
    /**Schaltet die Berechnung der Parameter im Gradma ein.
     */
    void gradMass() {
        gradMass=true;
    }
    
    
    
    /* (non-Javadoc)
     * @see parser.baeume.Baum#xVorhanden()
     */
    protected boolean xVorhanden() {
        return xVorhanden;
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() {
        String s;
        if (keinParameter) s=""+faktor;
        else s=""+faktor+parameter;
        return s;
    }
    
    
    /* (non-Javadoc)
     * @see parser.baeume.Baum#negativ()
     */
    public void negativ() {
        faktor=faktor*-1;
    }
    
    
    /* (non-Javadoc)
     * @see parser.baeume.Baum#f(double)
     */
    public double f(double x) {
        if (keinParameter) return faktor;
        if (xVorhanden) return faktor*x; 
        //																				 v 'A' wird abgezogen, damit 'A' dem Index 0 entspricht
        if (gradMass) return faktor*Math.toRadians(parser.Parser.parameter[this.parameter-'A']);
        else return faktor*parser.Parser.parameter[this.parameter-'A'];
    }


    /* (non-Javadoc)
     * @see parser.baeume.Baum#leiteAb()
     */
    public Baum leiteAb() {
        Blatt rueckgabe;
        //Fr alle Flle wie 2,7x oder 27x
        if (xVorhanden) rueckgabe= new Blatt(faktor, '?');
        //Fr 2,3 7,4
        else rueckgabe= new Blatt(0.0, '?');
        return rueckgabe;
    }


    /* (non-Javadoc)
     * @see parser.baeume.Baum#vereinfache()
     */
    public Baum vereinfache() {
        if (negativ) {
            negativ=false;
            faktor=faktor*(-1.0);
        }
        return this;
    }
}
