/*Enthlt alle Bume, die den Funktionsterm beinhalten, sowie Klassen zur Benutzung der Bume.
 * @author Stephan Hagebck
 */
package parser.baeume;


import java.util.ArrayList;


/**Diese Klasse enthlt den Funktionsterm in einer Baumstruktur. Auf Anforderung kann sie
 * Funktionswerte in Abhngigkeit von x berechnen.
 * @author Stephan Hagebck
 */
class Strichrechnung extends Baum{
    
    
    /**Instanziert einen Baum mit den Eigenschaften der Strichrechnung.
     */
    Strichrechnung() {
        liste=new ArrayList();
    }
    

    
    
	/* (non-Javadoc)
	 * @see parser.baeume.Baum#f(double)
	 */
	public double f(double x) {
	    double d=0.0;
        for (int i=0; i<liste.size(); i++) {
            d=d+((Baum)liste.get(i)).f(x);
        }
        if (negativ) d=d*-1;
        return d;
	}
	
	
	/* (non-Javadoc)
     * @see parser.baeume.Baum#negativ()
     */
    void negativ() {
        super.negativ();
    }
    

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() {
        String s="";
        for (int i=0; i<liste.size(); i++) {
            s='+'+liste.get(i).toString()+s;
        }
        s='('+s.substring(0, s.length())+')';
        if (negativ) s='-'+s;
        return s;
    }



    /* (non-Javadoc)
     * @see parser.baeume.Baum#leiteAb()
     */
    public Baum leiteAb() {
        Strichrechnung rueckgabe=new Strichrechnung();
        Baum baum;
        
        //Ein Summand mit x wird abgeleitet, ein absolutes Glied fllt weg.
        for (int i=0; i<liste.size(); i++) {
            baum= (Baum)liste.get(i);
            if (baum.xVorhanden()) rueckgabe.haengeAn(baum.leiteAb());
        }
        
        return rueckgabe;
    }


    /* (non-Javadoc)
     * @see parser.baeume.Baum#vereinfache()
     */
    public Baum vereinfache() {
        //Sollte diese Strichrechnung nur ein Element enthalten, fllt sie weg.
        if (liste.size()==1) {
            Baum baum=(Baum)liste.get(0);
            if (negativ) baum.negativ();
            return baum;
        }
        
        Baum baum;
        double y=0.0;
        

        for (int i=0; i<liste.size(); i++) {
            baum=(Baum)liste.get(i);
            //Zusammenfassung von 1+5-7 zu -1
            if (baum instanceof Blatt && ((Blatt)baum).keinParameter) {
                Blatt b=(Blatt)baum;
                if (b.negativ) y=y-b.faktor;
                else y=y+b.faktor;
                //Beim entfernen ndert sich die Listengre, weil alle Elemente nach vorne rutschen
                liste.remove(i--);
            }
            else if (baum instanceof Strichrechnung) {
                if (!baum.negativ) {
                    liste.remove(i--);
                    liste.addAll(baum.liste);
                }
                else liste.set(i, baum.vereinfache());
            }
            else liste.set(i, baum.vereinfache());
        }
        
        if (liste.size()==0) return new Blatt(y, '?');
        if (y!=0.0) liste.add(0, new Blatt(y, '?'));
        //weitere Vereinfachungen in Planung
        return this;
    }
}
