package sprachen;

import java.util.*;
/**
 * Diese Klasse funktioniert vom Prinzip her so wie die "Graphics", allerdings 
 * handelt es sich hier um eine eingestellte Sprache. Den Trick einen 
 * Konstruktor zu erstellen, der nur intern aufgerufen werden kann, verwenden 
 * wir hier, damit die Sprache nur einmal eingestellt muss und dann auf alle 
 * Klassen, die diese Spracheklasse verwenden wollen, bertragen wird. 
 * (Stichwort: Singleton Design Pattern)
 * @author Thilo Beckmann
 * @version 04.07.05
 */
public class Sprachen {
	private static Sprachen sprache = new Sprachen();
	private ListResourceBundle bundle;
	
	/** Konstruktor.
	 * Dieser Konstruktor ist private, damit er nur einmal erstellt wird;
	 * und dann alle Klassen wenn sie die Sprache holen wollen, dieselbe 
	 * Sprach-Datei/Klasse benutzen.
	 */
	private Sprachen(){
		//standartsprache ist deutsch :-)
		bundle = new Sprache_de();
	}
	
	/** Gibt die Referrenz auf DIE Sprache zurck.
	 * @return	Sprache
	 */
	public static Sprachen holeSprache(){
		return sprache;
	}
	/** Setzt aktuelle Sprache. 
	 * Hier kann man die eingestellte Sprache ndern. 
	 * @param bundle	setzt Sprachbundle auf bundle
	 */
	public void setzeSprachBundle (ListResourceBundle bundle){
		this.bundle = bundle;
	}
	/** Gibt Referrenz auf aktuelle Sprache.
	 * mit dieser Methode kann man die aktuell eingestellte Sprachklasse holen,
	 * um damit die Beschriftungen mit der richtigen Sprache zu versehen. 
	 * @return	gibt aktuelles Sprachbundle zurck (ListResourceBundle)
	 */
	public ListResourceBundle holeSprachBundle(){
		return bundle;
	}
}
